// KittyCat! Comm 1.0 for Windows 3.1
// Ansi-Rip-ZModem Window
// by Steven Lawrance and Joey Lawrance
// RIPscrip (c) TeleGraphix Communications

#define STRICT

#define RIP_BUTTON 0
#define RIP_FIELD  1 

#include <windowsx.h>
#include <windows.h>
#include <ddeml.h>
#include <stdlib.h>
#include <string.h>                    
#include <commdlg.h>

typedef struct tagAnsiText
{
  int UnderlineFlag;
  int BoldFlag;
  int BlinkFlag;
  int ReverseFlag;
  int ConcealedFlag;
  int LineWrapFlag;
  int TrueBrown;
  int ForegroundNum;
  int BackgroundNum;
} AnsiText;

typedef struct tagRipObject
{
  int Type;
  RECT box;
} RipObject;

const COLORREF   Black = PALETTERGB(0, 0, 0),
		 Red = PALETTERGB(191, 0, 0),
		 Green = PALETTERGB(0, 191, 0),
		 Brown = PALETTERGB(171, 87, 0),
		 Yellow = PALETTERGB(128, 128, 0),
		 Blue = PALETTERGB(0, 0, 191),
		 Magenta = PALETTERGB(191, 0, 191),
		 Cyan = PALETTERGB(0, 191, 191),
		 White = PALETTERGB(192, 192, 192),
		 LightBlack = PALETTERGB(128, 128, 128),
		 LightRed = PALETTERGB(255, 0, 0),
		 LightGreen = PALETTERGB(0, 255, 0),
		 LightYellow = PALETTERGB(255, 255, 0),
		 LightBlue = PALETTERGB(0, 0, 255),
		 LightMagenta = PALETTERGB(255, 0, 255),
		 LightCyan = PALETTERGB(0, 255, 255),
		 LightWhite = PALETTERGB(255, 255, 255);
AnsiText	 at, sat;
RipObject        ro[128];
HCONV		 hConv;
FARPROC		 fnDdeCallBack;
RECT		 RipTextWindow, RipViewport;
HWND		 ghWnd;
HLOCAL		 DataWait[10];
HSZ		 hszService, hszTopic, hszItem, hszModifyItem;
DWORD		 idInst = 0L, result;
HINSTANCE        ghInstance;
HDC		 ghDC;
RECT		 rect;
HFONT		 hFont, hFontOld;
//HBITMAP		 hBitmap;
HPALETTE	 hPal;
int 		 x, y, SavedX, SavedY,
		 BbsYN, RipProcessing, AnsiEnable, AnsiAutoSense, RipAutoSense,
		 UserDefault, ForegroundDefault, BackgroundDefault,
		 RipPalette[16], EgaPalette[64], RipColor;
char		 FileOpened[288];

// Function Prototypes
BOOL CALLBACK _export AboutDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK _export ConfigDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK _export ZModemDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
HDDEDATA FAR PASCAL _export DdeCallBackProc(UINT iType, UINT iFmt, HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD Data1, DWORD Data2);
LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam);
LPMEASUREITEMSTRUCT FAR PASCAL _export InitButton(LPMEASUREITEMSTRUCT lpmis, int ID, int X, int Y);
void FAR PASCAL _export RefreshPicPal(HWND hWnd, HPALETTE hNewPalette);
BOOL WritePrivateProfileInteger(LPCSTR lpszSection, LPCSTR lpszEntry, int Number, LPCSTR lpszFileName);
void WMCommand_Handler(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
void ProcessAnsi(unsigned char DataIn[2050]);
void WriteCharToScreen(unsigned char CharToWrite);
void WriteStringToScreen(unsigned char *StringToWrite, int Begin, int End);
COLORREF GetIndexColor(int Num, int TrueBrown);
int GetRipNumber(char Number1, char Number2);
int GetCharacter(char SearchString[2050], int Position);

/*******************************************/
#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdParam, int nCmdShow)
{
   char        ProgName[] = "AnsiRipZmodem_Wnd";
   HWND        hWnd;
   MSG         msg;
   HACCEL      hAcc;
   HMENU       hMenu;

   ghInstance = hInstance;
   if (!hPrevInstance)
   {
      WNDCLASS    wndclass;

      wndclass.lpszClassName = ProgName;
      wndclass.lpfnWndProc   = (WNDPROC) MainWndProc;
      wndclass.cbClsExtra    = 0;
      wndclass.cbWndExtra    = 0;
      wndclass.hInstance     = hInstance;
      wndclass.hIcon         = LoadIcon(ghInstance, "ANSIRIPZ");
      wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
      wndclass.hbrBackground = GetStockObject(BLACK_BRUSH);
      wndclass.lpszMenuName  = NULL;
      wndclass.style         = CS_VREDRAW | CS_HREDRAW;

      if (!RegisterClass(&wndclass)) exit(0);;
   }

   if (lstrcmp(lpCmdParam, "") == 0)
     lstrcpy(lpCmdParam, "ANSI-RIPscrip-ZModem Window");
   hWnd = CreateWindow(ProgName,lpCmdParam,    
                       WS_OVERLAPPEDWINDOW,     
		       GetPrivateProfileInt("Window", "XPos", CW_USEDEFAULT, "ANSIRIPZ.INI"),
		       GetPrivateProfileInt("Window", "YPos", CW_USEDEFAULT, "ANSIRIPZ.INI"),
		       GetPrivateProfileInt("Window", "Width", 657, "ANSIRIPZ.INI"),
		       GetPrivateProfileInt("Window", "Height", 419, "ANSIRIPZ.INI"),
		       NULL, NULL, hInstance, NULL);

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   hAcc = LoadAccelerators(hInstance, "MAINACL");
   hMenu = LoadMenu(ghInstance, "MAIN");
   if (BbsYN == TRUE)
   EnableMenuItem(hMenu, 106, MF_BYCOMMAND | MF_GRAYED);
   else
   {
     EnableMenuItem(hMenu, 102, MF_BYCOMMAND | MF_GRAYED);
     EnableMenuItem(hMenu, 103, MF_BYCOMMAND | MF_GRAYED);
     EnableMenuItem(hMenu, 100, MF_BYCOMMAND | MF_GRAYED);
   }
   SetMenu(hWnd, hMenu);
   while (GetMessage(&msg, NULL, 0, 0))
   {
     TranslateMessage(&msg);
     TranslateAccelerator(hWnd, hAcc, &msg);
     DispatchMessage(&msg);
   }
   DestroyMenu(hMenu);
   return msg.wParam;
}

/*******************************************/
LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam)
{
   switch (message)
   {
      case WM_CLOSE :
      {
	if (IsZoomed(hWnd) == FALSE)
	{
          RECT rect;
	  GetWindowRect(hWnd, &rect);
	  WritePrivateProfileInteger("Window", "XPos", rect.left, "ANSIRIPZ.INI"),
	  WritePrivateProfileInteger("Window", "YPos", rect.top, "ANSIRIPZ.INI"),
	  WritePrivateProfileInteger("Window", "Width", rect.right - rect.left, "ANSIRIPZ.INI");
	  WritePrivateProfileInteger("Window", "Height", rect.bottom - rect.top, "ANSIRIPZ.INI");
        }
        DestroyWindow(hWnd);
	return 0;
      }
      case WM_CREATE :
      {
	LPLOGPALETTE lp;
        HDDEDATA ghData;
        int i;
	RipProcessing = TRUE;
	BbsYN = TRUE;
	RipPalette[0] = 1;
	RipPalette[1] = 5;
        RipPalette[2] = 3;
	RipPalette[3] = 7;
	RipPalette[4] = 2;
	RipPalette[5] = 6;
	RipPalette[6] = 4;
	RipPalette[7] = 8;
	RipPalette[8] = 9;
	RipPalette[9] = 13;
	RipPalette[10] = 11;
	RipPalette[11] = 15;
	RipPalette[12] = 10;
	RipPalette[13] = 14;
	RipPalette[14] = 12;
	RipPalette[15] = 16;
        memset(EgaPalette, 0, sizeof(int) * 64);
	EgaPalette[0] = 1;
	EgaPalette[1] = 5;
	EgaPalette[2] = 3;
	EgaPalette[3] = 7;
	EgaPalette[4] = 2;
	EgaPalette[5] = 6;
	EgaPalette[7] = 4;
	EgaPalette[20] = 8;
	EgaPalette[56] = 9;
	EgaPalette[57] = 13;
	EgaPalette[58] = 11;
	EgaPalette[59] = 15;
	EgaPalette[60] = 10;
	EgaPalette[61] = 14;
	EgaPalette[62] = 12;
	EgaPalette[63] = 16;
	for (i=0;i<=9;i++)
          DataWait[i] = NULL;
	memset(FileOpened, NULL, 288);
	memset(&at, NULL, sizeof(at));
	memset(&sat, NULL, sizeof(at));
	x = 0;
	y = 0;
	SavedX = 0;
        SavedY = 0;
        ghWnd = hWnd;
        RipProcessing = GetPrivateProfileInt("RIPscrip", "ProcessingFlag", 1, "ANSIRIPZ.INI");
	RipAutoSense = GetPrivateProfileInt("RIPscrip", "AutoSensingEnable", 1, "ANSIRIPZ.INI");
	AnsiEnable = GetPrivateProfileInt("ANSI", "ProcessingFlag", 1, "ANSIRIPZ.INI");
	AnsiAutoSense = GetPrivateProfileInt("ANSI", "AutoSensingFlag", 1, "ANSIRIPZ.INI");
	at.TrueBrown = GetPrivateProfileInt("ANSI", "TrueBrown", 1, "ANSIRIPZ.INI");
	UserDefault = GetPrivateProfileInt("ANSI", "UseColorAsDefault", 0, "ANSIRIPZ.INI");
	if (UserDefault == FALSE)
	{
	  ForegroundDefault = 8;
          BackgroundDefault = 1;
        }
	else
	{
	  ForegroundDefault = GetPrivateProfileInt("ANSI", "Foreground", 8, "ANSIRIPZ.INI");
	  BackgroundDefault = GetPrivateProfileInt("ANSI", "Background", 1, "ANSIRIPZ.INI");
	}
	fnDdeCallBack = MakeProcInstance((FARPROC)DdeCallBackProc, ghInstance);
        idInst = 0;
        result = DdeInitialize(&idInst, (PFNCALLBACK)fnDdeCallBack, APPCMD_CLIENTONLY, 0L);
        if (result != DMLERR_NO_ERROR)
        {
          char ErrorText[100];
          memset(ErrorText, NULL, 100);
	  MessageBeep(MB_ICONSTOP);
	  strcpy(ErrorText, "Cannot initialize DDE!");
	  if (result == DMLERR_DLL_USAGE)
            strcat(ErrorText, "  DLL usage error.");
	  if (result == DMLERR_INVALIDPARAMETER)
            strcat(ErrorText, "  Invalid parameter (internal error).");
	  if (result == DMLERR_SYS_ERROR)
	    strcat(ErrorText, "  System error (internal error).");
	  MessageBox(hWnd, ErrorText, "Fatal Error", MB_OK | MB_ICONSTOP);
	  DestroyWindow(hWnd);
	  return FALSE;
        }
        hszService = DdeCreateStringHandle(idInst, "catcomm", CP_WINANSI);
        hszTopic = DdeCreateStringHandle(idInst, "comm", CP_WINANSI);
        hszItem = DdeCreateStringHandle(idInst, "comm", CP_WINANSI);
	hszModifyItem = DdeCreateStringHandle(idInst, "modify", CP_WINANSI);
	if ((hszItem == NULL) || (hszTopic == NULL) || (hszService == NULL))
        {
          MessageBeep(MB_ICONSTOP);
	  MessageBox(hWnd, "Cannot create one or more of the DDE string handles!", "Fatal Error", MB_OK | MB_ICONSTOP);
	  DdeUninitialize(idInst);
	  idInst = 0L;
	  DestroyWindow(hWnd);
	  return FALSE;
        }
        hConv = DdeConnect(idInst, hszService, hszTopic, (PCONVCONTEXT) NULL);
        if (hConv == NULL)
        {
	  BbsYN = FALSE;
	  DdeFreeStringHandle(idInst, hszService);
	  DdeFreeStringHandle(idInst, hszTopic);
	  DdeFreeStringHandle(idInst, hszItem);
	  DdeFreeStringHandle(idInst, hszModifyItem);
	  DdeUninitialize(idInst);
	  idInst = 0L;
/*  	  ghDC = GetDC(hWnd);
	  hFont = GetStockFont(OEM_FIXED_FONT);
	  hFontOld = SelectFont(ghDC, hFont);
	  GetWindowRect(hWnd, &rect);
	  SetBkMode(ghDC, OPAQUE);
	  SetBkColor(ghDC, Black);
	  SetTextColor(ghDC, White);
	  at.ForegroundNum = ForegroundDefault;
          at.BackgroundNum = BackgroundDefault;
	  at.LineWrapFlag = TRUE;
	  at.UnderlineFlag = FALSE;
	  at.BoldFlag = FALSE;
	  at.BlinkFlag = FALSE;
	  at.ReverseFlag = FALSE;
	  at.ConcealedFlag = FALSE;
          lp = (LPLOGPALETTE) LocalAlloc(LPTR, sizeof(LOGPALETTE) + 1 * sizeof(PALETTEENTRY));
	  lp->palVersion = 0x300;
	  lp->palNumEntries = 1;
	  lp->palPalEntry[0].peRed = 171;
	  lp->palPalEntry[0].peGreen = 87;
	  lp->palPalEntry[0].peBlue = 0;
	  lp->palPalEntry[0].peFlags = NULL;
	  hPal = CreatePalette(lp);
	  LocalFree((HLOCAL) lp);
    	  if (hPal == NULL)
	  {
	    MessageBeep(MB_ICONEXCLAMATION);
	    MessageBox(hWnd, "Cannot create palette!  TrueBrown will not work.", "Warning", MB_OK | MB_ICONEXCLAMATION);
	  }*/
          goto InitWindow;
	  return 0;
        }
	ghData = DdeCreateDataHandle(idInst, "OLDANSI\0", 8, 0L, hszItem, CF_TEXT, NULL);
	if (ghData == NULL)
        {
	  MessageBeep(MB_ICONSTOP);
	  MessageBox(hWnd, "Cannot create data handle!", "Fatal Error", MB_OK | MB_ICONSTOP);
	  DdeDisconnect(hConv);
	  DdeFreeStringHandle(idInst, hszService);
	  DdeFreeStringHandle(idInst, hszTopic);
	  DdeFreeStringHandle(idInst, hszItem);
	  DdeFreeStringHandle(idInst, hszModifyItem);
	  DdeUninitialize(idInst);
	  idInst = 0L;
	  DestroyWindow(hWnd);
	  return FALSE;
        }  
        DdeClientTransaction((LPBYTE) ghData, -1, hConv, hszItem, CF_TEXT, XTYP_POKE, 1000, &result);
	result = DdeGetLastError(idInst);
        if (result != DMLERR_NO_ERROR)
        {
	  MessageBeep(MB_ICONSTOP);
	  MessageBox(hWnd, "Cannot send to server!", "Fatal Error", MB_OK | MB_ICONSTOP);
	  DdeDisconnect(hConv);
	  DdeFreeStringHandle(idInst, hszService);
	  DdeFreeStringHandle(idInst, hszTopic);
	  DdeFreeStringHandle(idInst, hszItem);
	  DdeFreeStringHandle(idInst, hszModifyItem);
	  DdeUninitialize(idInst);
	  idInst = 0L;
	  DestroyWindow(hWnd);
	  return FALSE;
        }
//	if (ghData)
//          DdeFreeDataHandle(ghData);
	ghData = DdeCreateDataHandle(idInst, "terminalmode\0", 14, 0L, hszModifyItem, CF_TEXT, NULL);
	DdeClientTransaction((LPBYTE) ghData, -1, hConv, hszModifyItem, CF_TEXT, XTYP_POKE, 1000, &result);
//	if (ghData)
//          DdeFreeDataHandle(ghData);
	DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTART | XTYPF_ACKREQ, 1000, &result);
        result = DdeGetLastError(idInst);
        if (result != DMLERR_NO_ERROR)
        {
	  MessageBeep(MB_ICONSTOP);
	  MessageBox(hWnd, "Cannot establish advise loop with server!", "Fatal Error", MB_OK | MB_ICONSTOP);
	  DdeDisconnect(hConv);
	  DdeFreeStringHandle(idInst, hszService);
	  DdeFreeStringHandle(idInst, hszTopic);
	  DdeFreeStringHandle(idInst, hszItem);
	  DdeFreeStringHandle(idInst, hszModifyItem);
	  DdeUninitialize(idInst);
	  idInst = 0L;
	  DestroyWindow(hWnd);
	  return FALSE;
	}
        InitWindow:
        ghDC = GetDC(hWnd);
	hFont = CreateFont(12, 0, 0, 0, 0, 0, 0, 0, 255, 0, 0, 0, 0, (LPCSTR) "Terminal");
	hFontOld = SelectFont(ghDC, hFont);
	GetWindowRect(hWnd, &rect);
	at.ForegroundNum = ForegroundDefault;
        at.BackgroundNum = BackgroundDefault;
	at.LineWrapFlag = TRUE;
	at.UnderlineFlag = FALSE;
	at.BoldFlag = FALSE;
	at.BlinkFlag = FALSE;
	at.ReverseFlag = FALSE;
	at.ConcealedFlag = FALSE;
	SetBkMode(ghDC, OPAQUE);
	SetBkColor(ghDC, Black);
        SetTextColor(ghDC, White);
	lp = (LOGPALETTE*) LocalAlloc(LPTR, sizeof(LOGPALETTE) + 17 * sizeof(PALETTEENTRY));
	lp->palVersion = 0x300;
	lp->palNumEntries = 17;
	lp->palPalEntry[0].peRed = 0;
	lp->palPalEntry[0].peGreen = 0;
	lp->palPalEntry[0].peBlue = 0;
	lp->palPalEntry[0].peFlags = NULL;
	lp->palPalEntry[1].peRed = 191;
	lp->palPalEntry[1].peGreen = 0;
	lp->palPalEntry[1].peBlue = 0;
	lp->palPalEntry[1].peFlags = NULL;
	lp->palPalEntry[2].peRed = 0;
	lp->palPalEntry[2].peGreen = 191;
	lp->palPalEntry[2].peBlue = 0;
	lp->palPalEntry[2].peFlags = NULL;
	lp->palPalEntry[3].peRed = 128;
	lp->palPalEntry[3].peGreen = 128;
	lp->palPalEntry[3].peBlue = 0;
	lp->palPalEntry[3].peFlags = NULL;
	lp->palPalEntry[4].peRed = 0;
	lp->palPalEntry[4].peGreen = 0;
	lp->palPalEntry[4].peBlue = 191;
	lp->palPalEntry[4].peFlags = NULL;
	lp->palPalEntry[5].peRed = 191;
	lp->palPalEntry[5].peGreen = 0;
	lp->palPalEntry[5].peBlue = 191;
	lp->palPalEntry[5].peFlags = NULL;
	lp->palPalEntry[6].peRed = 0;
	lp->palPalEntry[6].peGreen = 191;
	lp->palPalEntry[6].peBlue = 191;
	lp->palPalEntry[6].peFlags = NULL;
	lp->palPalEntry[7].peRed = 192;
	lp->palPalEntry[7].peGreen = 192;
	lp->palPalEntry[7].peBlue = 192;
	lp->palPalEntry[7].peFlags = NULL;
	lp->palPalEntry[8].peRed = 128;
	lp->palPalEntry[8].peGreen = 128;
	lp->palPalEntry[8].peBlue = 128;
	lp->palPalEntry[8].peFlags = NULL;
	lp->palPalEntry[9].peRed = 255;
	lp->palPalEntry[9].peGreen = 0;
	lp->palPalEntry[9].peBlue = 0;
	lp->palPalEntry[9].peFlags = NULL;
	lp->palPalEntry[10].peRed = 0;
	lp->palPalEntry[10].peGreen = 255;
	lp->palPalEntry[10].peBlue = 0;
	lp->palPalEntry[10].peFlags = NULL;
	lp->palPalEntry[11].peRed = 255;
	lp->palPalEntry[11].peGreen = 255;
	lp->palPalEntry[11].peBlue = 0;
	lp->palPalEntry[11].peFlags = NULL;
	lp->palPalEntry[12].peRed = 0;
	lp->palPalEntry[12].peGreen = 0;
	lp->palPalEntry[12].peBlue = 255;
	lp->palPalEntry[12].peFlags = NULL;
	lp->palPalEntry[13].peRed = 255;
	lp->palPalEntry[13].peGreen = 0;
	lp->palPalEntry[13].peBlue = 255;
	lp->palPalEntry[13].peFlags = NULL;
	lp->palPalEntry[14].peRed = 0;
	lp->palPalEntry[14].peGreen = 255;
	lp->palPalEntry[14].peBlue = 255;
	lp->palPalEntry[14].peFlags = NULL;
	lp->palPalEntry[15].peRed = 255;
	lp->palPalEntry[15].peGreen = 255;
	lp->palPalEntry[15].peBlue = 255;
	lp->palPalEntry[15].peFlags = NULL;
	lp->palPalEntry[16].peRed = 170;
	lp->palPalEntry[16].peGreen = 85;
	lp->palPalEntry[16].peBlue = 0;
	lp->palPalEntry[16].peFlags = NULL;
	hPal = CreatePalette(lp);
	LocalFree((HLOCAL) lp);
	if (hPal == NULL)
        {
	  MessageBeep(MB_ICONEXCLAMATION);
	  MessageBox(hWnd, "Cannot create palette!  TrueBrown will not work.", "Warning", MB_OK | MB_ICONEXCLAMATION);
        }
//	hBitmap = CreateCompatibleBitmap(ghDC, 640, 480);
	return 0;
      }
      case WM_SETFOCUS :
      {
	if (hPal)
        {
          HPALETTE hOldPal;
	  hOldPal = SelectPalette(ghDC, hPal, FALSE);
	  RealizePalette(ghDC);
	  SelectPalette(ghDC, hOldPal, FALSE);
	  DeleteObject(hOldPal);
        }
      }
      case WM_PAINT :
      { 
/*  	HDC MemDC;
	RECT rect;
        MemDC = CreateCompatibleDC(ghDC);
        SelectObject(MemDC, hBitmap);
        GetClientRect(hWnd, &rect);
        BitBlt(ghDC, 0, 0, rect.right, rect.bottom, MemDC, 0, 0, SRCCOPY);
	DeleteDC(MemDC);*/
	ValidateRect(hWnd, NULL);
	return 0;
      }
      case WM_COMMAND :
      {
	return HANDLE_WM_COMMAND(hWnd, wParam, lParam, WMCommand_Handler);
      }
      case WM_CHAR :
      {
        HDDEDATA ghData;
	if (BbsYN == TRUE)
        {
	  char KeyToSend[10];
	  memset(KeyToSend, NULL, 10);
	  KeyToSend[0] = (char) wParam;
	  ghData = DdeCreateDataHandle(idInst, KeyToSend, 10, 0L, hszItem, CF_TEXT, 0);
	  DdeClientTransaction(ghData, -1, hConv, hszItem, CF_TEXT, XTYP_POKE, 10, &result);
	}
	if (BbsYN == FALSE)
	{
	  WriteCharToScreen((char) wParam);
        }
        return 0;
      }
      case WM_DESTROY :
      {
//	FreeProcInstance((FARPROC)tp);
	if (BbsYN == TRUE)
        {
	  DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, 1000, &result);
	  FreeProcInstance((FARPROC)fnDdeCallBack);
	  if (idInst != NULL)
  	  {
	    if (DdeDisconnect(hConv) == 0)
  	    {
  	      MessageBeep(MB_ICONSTOP);
  	      MessageBox(ghWnd, "Cannot disconnect from server!  Exit KittyCat! Comm and run again.", "Fatal Error", MB_OK | MB_ICONSTOP);
	    }
	    if ((DdeFreeStringHandle(idInst, hszService) || DdeFreeStringHandle(idInst, hszTopic) || DdeFreeStringHandle(idInst, hszItem) || DdeFreeStringHandle(idInst, hszModifyItem)) == 0)
  	    {
  	      MessageBeep(MB_ICONSTOP);
  	      MessageBox(ghWnd, "Cannot free one or more of the DDE string handles!  Exit KittyCat! Comm and run again.", "Fatal Error", MB_OK | MB_ICONSTOP);
  	    }
  	    if (DdeUninitialize(idInst) == 0)
  	    {
              MessageBeep(MB_ICONSTOP);
  	      MessageBox(ghWnd, "Cannot uninitialize DDE!  Exit KittyCat! Comm and run again.", "Fatal Error", MB_OK | MB_ICONSTOP);
	    }
          }
	}
//        DeleteObject(hBitmap);
	SelectFont(ghDC, hFontOld);
	DeleteObject(hFont);
	DeleteObject(hFontOld);
	DeleteObject(hPal);
	ReleaseDC(hWnd, ghDC);
	PostQuitMessage(0);
        return 0;
      }
   }
   return DefWindowProc (hWnd, message, wParam, lParam);
}

#pragma argsused
HDDEDATA FAR PASCAL _export DdeCallBackProc(UINT iType, UINT iFmt, HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD Data1, DWORD Data2)
{
  switch (iType)
  {
    case XTYP_ADVDATA :
    {
      char DataIn[2050];
      DdeGetData(hData, DataIn, 2048, 0);
      if (strcmp(DataIn, "") != 0)
	ProcessAnsi(DataIn);
      return NULL;
    }
  }
  return NULL;
}

void WriteCharToScreen(unsigned char CharToWrite)
{
  char StringToWrite[5];
  memset(StringToWrite, NULL, 5);
  StringToWrite[0] = CharToWrite;
  WriteStringToScreen(StringToWrite, 0, 0);
}

void WriteStringToScreen(unsigned char *StringToWrite, int Begin, int End)
{
  HPALETTE hOldPal;
  RECT rect;
//  HDC MemDC = CreateCompatibleDC(ghDC);
  int Current;
  unsigned char CharToWrite[3];
  hOldPal = SelectPalette(ghDC, hPal, FALSE);
  GetClientRect(ghWnd, &rect);
  SetTextColor(ghDC, GetIndexColor(at.ForegroundNum, at.TrueBrown));
  SetBkColor(ghDC, GetIndexColor(at.BackgroundNum, at.TrueBrown));
  for (Current=Begin;Current<=End;Current++)
  {
	 switch (StringToWrite[Current])
	 {
		case 0x0a :
		{
		  // Line Feed
		  if (BbsYN == TRUE)
		  {
			 x = 0;
			 y = y + 1;
			 if (y > 30)
				y = 0;
		  }
		  break;
		}
		case 13 :
		{
		  // Enter Key
		  x = 0;
		  if (BbsYN == FALSE)
		  {
			 y = y + 1;
			 if (y > 30)
		 y = 0;
		  }
	break;
		}
		case 8 :
		{
		  // Backspace
		  if (x - 1 >= 0)
		  {
	  TextOut(ghDC, x*8, y*12, " ", 1);
	  x = x - 1;
		  }
	break;
		}
		default :
		{
		  memset(CharToWrite, NULL, 3);
		  CharToWrite[0] = StringToWrite[Current];
		  x = x + 1;
		  if (x > 80)
		  {
			 y = y + 1;
			 x = 1;
		  }
		  if (y > 30)
	  y = 0;
	TextOut(ghDC, x*8, y*12, CharToWrite, 1);
	break;
		}
	 }
  }
//  SelectObject(MemDC, hBitmap);
  GetClientRect(ghWnd, &rect);
//  BitBlt(MemDC, 0, 0, rect.right, rect.bottom, ghDC, 0, 0, SRCCOPY);
  SelectPalette(ghDC, hOldPal, FALSE);
  DeleteObject(hOldPal);
//  DeleteDC(MemDC);
}

int GetCharacter(char SearchString[2050], int Position)
{
  char TmpStr[10];
  int ts = 0;
  memset(TmpStr, NULL, 10);
  while ((SearchString[Position] != ';') && (SearchString[Position] != 'm') && (SearchString[Position] != 'A') && (SearchString[Position] != 'B') && (SearchString[Position] != 'C') && (SearchString[Position] != 'D') && (SearchString[Position] != 'H') && (SearchString[Position] != 'f'))
  {
	 TmpStr[ts] = SearchString[Position];
	 ts = ts + 1;
	 Position = Position + 1;
	 if (ts == 9)
		SearchString[Position] = ';';
  }
  Position = Position + 1;
  return atoi(TmpStr);
}

void ProcessAnsi(unsigned char DataIn[2050])
{
 int i, ReadFlag = FALSE, BeginPos = 0;
 int DataInLen = strlen(DataIn) - 1;
 char SearchString[5];
 memset(SearchString, NULL, 5);
 SearchString[0] = 27;
 SearchString[1] = '!';
 if (strpbrk(DataIn, SearchString) != NULL)
 {
  for (i = 0; i <= DataInLen; i++)
  {
    if ((DataIn[i] == '!') && (DataIn[i+1] == '|') && (RipProcessing == TRUE))
    {
      // RIPscrip Processor
      int EscPos = i + 1, ContinueFlag = TRUE;
      if (BeginPos != i)
      {
	WriteStringToScreen(DataIn, BeginPos, i-1);
        BeginPos = i;
		}
      while (DataIn[EscPos] == '|')
      {
        EscPos = EscPos + 1;
	if (DataIn[EscPos] == '0')
          EscPos = EscPos + 1;
	switch (DataIn[EscPos])
	{
	  case 'w' :
	  {
	    // RIP_TEXT_WINDOW
            EscPos = EscPos + 11;
	    break;
	  }
	  case 'v' :
	  {
	    // RIP_VIEWPORT
            EscPos = EscPos + 9;
	    break;
	  }
	  case '*' :
	  {
	    // RIP_RESET_WINDOWS
            EscPos = EscPos + 1;
	    break;
	  }
	  case 'e' :
	  {
	    // RIP_ERASE_WINDOW
            EscPos = EscPos + 1;
	    break;
	  }
	  case 'E' :
	  {
	    // RIP_ERASE_VIEW
            EscPos = EscPos + 1;
	    break;
	  }
	  case 'g' :
	  {
	    // RIP_GOTOXY
	    x = GetRipNumber(DataIn[EscPos+1], DataIn[EscPos+2]) - 1;
	    y = GetRipNumber(DataIn[EscPos+3], DataIn[EscPos+4]);
	    EscPos = EscPos + 5;
	    break;
	  }
	  case 'H' :
	  {
	    // RIP_HOME
	    x = 0;
            y = 0;
            EscPos = EscPos + 1;
	    break;
	  }
	  case '>' :
	  {
	    // RIP_ERASE_EOL
				EscPos = EscPos + 1;
	    break;
	  }
	  case 'c' :
	  {
	    // RIP_COLOR
	    RipColor = RipPalette[GetRipNumber(DataIn[EscPos+1], DataIn[EscPos+2])];
	    EscPos = EscPos + 3;
	    break;
	  }
	  case 'Q' :
	  {
	    // RIP_SET_PALETTE
            RipPalette[0] = EgaPalette[GetRipNumber(DataIn[EscPos+1], DataIn[EscPos+2])];
	    RipPalette[1] = EgaPalette[GetRipNumber(DataIn[EscPos+3], DataIn[EscPos+4])];
	    RipPalette[2] = EgaPalette[GetRipNumber(DataIn[EscPos+5], DataIn[EscPos+6])];
	    RipPalette[3] = EgaPalette[GetRipNumber(DataIn[EscPos+7], DataIn[EscPos+8])];
	    RipPalette[4] = EgaPalette[GetRipNumber(DataIn[EscPos+9], DataIn[EscPos+10])];
	    RipPalette[5] = EgaPalette[GetRipNumber(DataIn[EscPos+11], DataIn[EscPos+12])];
		 RipPalette[6] = EgaPalette[GetRipNumber(DataIn[EscPos+13], DataIn[EscPos+14])];
	    RipPalette[7] = EgaPalette[GetRipNumber(DataIn[EscPos+15], DataIn[EscPos+16])];
	    RipPalette[8] = EgaPalette[GetRipNumber(DataIn[EscPos+17], DataIn[EscPos+18])];
	    RipPalette[9] = EgaPalette[GetRipNumber(DataIn[EscPos+19], DataIn[EscPos+20])];
	    RipPalette[10] = EgaPalette[GetRipNumber(DataIn[EscPos+21], DataIn[EscPos+22])];
	    RipPalette[11] = EgaPalette[GetRipNumber(DataIn[EscPos+23], DataIn[EscPos+24])];
	    RipPalette[12] = EgaPalette[GetRipNumber(DataIn[EscPos+25], DataIn[EscPos+26])];
	    RipPalette[13] = EgaPalette[GetRipNumber(DataIn[EscPos+27], DataIn[EscPos+28])];
	    RipPalette[14] = EgaPalette[GetRipNumber(DataIn[EscPos+29], DataIn[EscPos+30])];
	    RipPalette[15] = EgaPalette[GetRipNumber(DataIn[EscPos+31], DataIn[EscPos+32])];
	    EscPos = EscPos + 33;
	    break;
	  }
	  case 'a' :
	  {
	    // RIP_ONE_PALETTE
            RipPalette[GetRipNumber(DataIn[EscPos+1], DataIn[EscPos+2])] = EgaPalette[GetRipNumber(DataIn[EscPos+3], DataIn[EscPos+4])];
            EscPos = EscPos + 5;
	    break;
	  }
	  case 'W' :
	  {
	    // RIP_WRITE_MODE
            EscPos = EscPos + 3;
	    break;
	  }
	  case 'm' :
	  {
	    // RIP_MOVE
            EscPos = EscPos + 5;
	    break;
	  }
	  case 'T' :
	  {
	    // RIP_TEXT
            EscPos = EscPos + 1;
	    break;
	  }
	  case '@' :
	  {
	    // RIP_TEXT_XY
            EscPos = EscPos + 5;
	    break;
	  }
	  case 'Y' :
	  {
	    // RIP_FONT_STYLE
            EscPos = EscPos + 9;
	    break;
	  }
	  case 'X' :
	  {
	    // RIP_PIXEL
	    HPALETTE hOldPal;
	    hOldPal = SelectPalette(ghDC, hPal, FALSE);
	    SetPixel(ghDC, GetRipNumber(DataIn[EscPos+1], DataIn[EscPos+2]), GetRipNumber(DataIn[EscPos+3], DataIn[EscPos+4]), GetIndexColor(RipColor, at.TrueBrown));
	    SelectPalette(ghDC, hOldPal, FALSE);
	    DeleteObject(hOldPal);
	    EscPos = EscPos + 5;
	    break;
	  }
	  case 'L' :
	  {
	    // RIP_LINE
	    HPEN hPen = CreatePen(PS_SOLID, 1, GetIndexColor(RipColor, at.TrueBrown)), hPenOld;
 	    HPALETTE hOldPal;
	    hOldPal = SelectPalette(ghDC, hPal, FALSE);
	    hPenOld = SelectObject(ghDC, hPen);
	    MoveTo(ghDC, GetRipNumber(DataIn[EscPos+1], DataIn[EscPos+2]), GetRipNumber(DataIn[EscPos+3], DataIn[EscPos+4]));
	    LineTo(ghDC, GetRipNumber(DataIn[EscPos+5], DataIn[EscPos+6]), GetRipNumber(DataIn[EscPos+7], DataIn[EscPos+8]));
	    SelectObject(ghDC, hPenOld);
	    SelectPalette(ghDC, hOldPal, FALSE);
	    DeleteObject(hOldPal);
	    DeleteObject(hPen);
            DeleteObject(hPenOld);
            EscPos = EscPos + 9;
	    break;
	  }
	  case 'R' :
	  {
	    // RIP_RECTANGLE
	    HPEN hPen = CreatePen(PS_SOLID, 1, GetIndexColor(RipColor, at.TrueBrown)), hPenOld;
 	    HPALETTE hOldPal;
	    hOldPal = SelectPalette(ghDC, hPal, FALSE);
	    hPenOld = SelectObject(ghDC, hPen);
	    MoveTo(ghDC, GetRipNumber(DataIn[EscPos+1], DataIn[EscPos+2]), GetRipNumber(DataIn[EscPos+3], DataIn[EscPos+4]));
	    LineTo(ghDC, GetRipNumber(DataIn[EscPos+1], DataIn[EscPos+2]), GetRipNumber(DataIn[EscPos+7], DataIn[EscPos+8]));
	    LineTo(ghDC, GetRipNumber(DataIn[EscPos+5], DataIn[EscPos+6]), GetRipNumber(DataIn[EscPos+7], DataIn[EscPos+8]));
	    LineTo(ghDC, GetRipNumber(DataIn[EscPos+5], DataIn[EscPos+6]), GetRipNumber(DataIn[EscPos+3], DataIn[EscPos+4]));
	    LineTo(ghDC, GetRipNumber(DataIn[EscPos+1], DataIn[EscPos+2]), GetRipNumber(DataIn[EscPos+3], DataIn[EscPos+4]));
	    SelectObject(ghDC, hPenOld);
	    SelectPalette(ghDC, hOldPal, FALSE);
	    DeleteObject(hOldPal);
	    DeleteObject(hPen);
            DeleteObject(hPenOld);
	    EscPos = EscPos + 9;
	    break;
	  }
	  case 'B' :
	  {
	    // RIP_BAR
	    HPEN hBrush = CreateSolidBrush(GetIndexColor(RipColor, at.TrueBrown)), hBrushOld;
 	    HPALETTE hOldPal;
	    hOldPal = SelectPalette(ghDC, hPal, FALSE);
	    hBrushOld = SelectObject(ghDC, hBrush);
	    Rectangle(ghDC, GetRipNumber(DataIn[EscPos+1], DataIn[EscPos+2]), GetRipNumber(DataIn[EscPos+3], DataIn[EscPos+4]), GetRipNumber(DataIn[EscPos+5], DataIn[EscPos+6]), GetRipNumber(DataIn[EscPos+7], DataIn[EscPos+8]));
	    SelectObject(ghDC, hBrushOld);
	    SelectPalette(ghDC, hOldPal, FALSE);
	    DeleteObject(hOldPal);
	    DeleteObject(hBrush);
	    DeleteObject(hBrushOld);
	    EscPos = EscPos + 9;
	    break;
	  }
	  case 'O' :
	  {
	    // RIP_OVAL
            EscPos = EscPos + 15;
	    break;
	  }
	  case 'o' :
	  {
	    // RIP_FILLED_OVAL
            EscPos = EscPos + 9;
	    break;
	  }
	  case 'A' :
	  {
	    // RIP_ARC
            EscPos = EscPos + 11;
	    break;
	  }
	  case 'V' :
	  {
	    // RIP_OVAL_ARC
            EscPos = EscPos + 13;
	    break;
	  }
	  case 'I' :
	  {
	    // RIP_PIE_SLICE
            EscPos = EscPos + 11;
	    break;
	  }
	  case 'i' :
	  {
	    // RIP_OVAl_PIE_SLICE
            EscPos = EscPos + 13;
	    break;
	  }
	  case 'Z' :
	  {
	    // RIP_BEZIER
            EscPos = EscPos + 19;
	    break;
	  }
	  case 'P' :
	  {
	    // RIP_POLYGON
            EscPos = EscPos + 3;
	    break;
	  }
	  case 'p' :
	  {
	    // RIP_FILL_POLYGON
            EscPos = EscPos + 3;
	    break;
	  }
	  case 'l' :
	  {
	    // RIP_POLYLINE
            EscPos = EscPos + 3;
	    break;
	  }
	  case 'F' :
	  {
	    // RIP_FILL
            EscPos = EscPos + 7;
	    break;
	  }
	  case '=' :
	  {
	    // RIP_LINE_STYLE
            EscPos = EscPos + 9;
	    break;
	  }
	  case 'S' :
	  {
	    // RIP_FILL_STYLE
            EscPos = EscPos + 5;
	    break;
	  }
	  case 's' :
	  {
	    // RIP_FILL_PATTERN
            EscPos = EscPos + 19;
	    break;
	  }
	  case '1' :
	  {
	    // Level 1
            EscPos = EscPos + 1;
	    switch(DataIn[EscPos])
	    {
	      case 'M' :
	      {
 	        // RIP_MOUSE
                EscPos = EscPos + 18;
		break;
	      }
	      case 'K' :
	      {
 	        // RIP_KILL_MOUSE_FIELDS
                EscPos = EscPos + 1;
		break;
	      }
	      case 'T' :
	      {
 	        // RIP_BEGIN_TEXT
                EscPos = EscPos + 9;
		break;
	      }
	      case 't' :
	      {
 	        // RIP_REGION_TEXT
                EscPos = EscPos + 2;
		break;
	      }
	      case 'E' :
	      {
 	        // RIP_END_TEXT
                EscPos = EscPos + 1;
		break;
	      }
	      case 'C' :
	      {
 	        // RIP_GET_IMAGE
                EscPos = EscPos + 10;
		break;
	      }
	      case 'P' :
	      {
 	        // RIP_PUT_IMAGE
                EscPos = EscPos + 8;
		break;
	      }
	      case 'W' :
	      {
 	        // RIP_WRITE_ICON
                EscPos = EscPos + 2;
		break;
	      }
	      case 'I' :
	      {
 	        // RIP_LOAD_ICON
                EscPos = EscPos + 10;
		break;
	      }
	      case 'B' :
	      {
 	        // RIP_BUTTON_STYLE
                EscPos = EscPos + 37;
		break;
	      }
	      case 'U' :
	      {
 	        // RIP_BUTTON
                EscPos = EscPos + 13;
		break;
	      }
	      case 'D' :
	      {
 	        // RIP_DEFINE
                EscPos = EscPos + 6;
		break;
	      }
	      case 27 :
	      {
 	        // RIP_QUERY
                EscPos = EscPos + 5;
		break;
	      }
	      case 'G' :
	      {
 	        // RIP_COPY_REGION
		EscPos = EscPos + 13;
		break;
	      }
	      case 'R' :
	      {
 	        // RIP_READ_SCENE
                EscPos = EscPos + 9;
		break;
	      }
	      case 'F' :
	      {
 	        // RIP_FILE_QUERY
                EscPos = EscPos + 7;
		break;
	      }
	      default :
	      {
                goto Abort;
		break;
	      }
	    }
	    break;
	  }
	  case '9' :
	  {
	    // Level 9 (System Level)
            EscPos = EscPos + 1;
	    switch(DataIn[EscPos])
	    {
	      case 27 :
	      {
 	        // RIP_ENTER_BLOCK_MODE
                EscPos = EscPos + 9;
		break;
	      }
	      default :
	      {
		goto Abort;
     	        break;
	      }
	    }
	    break;
	  }
	  case '#' :
	  {
	    // RIP_NO_MORE
            EscPos = EscPos + 1;
	    break;
	  }
	  default :
	  {
            goto Abort;
            break;
	  }
	}
	i = EscPos;
        BeginPos = i + 1;
      }
    }
    if ((DataIn[i] == 27) && (DataIn[i+1] == '[') && (AnsiEnable == TRUE))
    {
      // ANSI Processor
      int EscPos = i + 2, NumberCount = 0, CharCount = 0;
      int Number[128], tmp;
      char TmpChar[5];
      if (BeginPos != i)
      {
	WriteStringToScreen(DataIn, BeginPos, i-1);
        BeginPos = i;
      }
      ReadFlag = TRUE;
      memset(TmpChar, NULL, 5);
      for (tmp=0;tmp<=127;tmp++)
        Number[tmp] = -1;
      while ((((DataIn[EscPos] <= 57) && (DataIn[EscPos] >= 48)) || (DataIn[EscPos] == ';') || (DataIn[EscPos] == '?')) && (EscPos <= DataInLen))
      {
	switch (DataIn[EscPos])
	{
	  case '?' :
          {
	    EscPos = EscPos + 1;
            break;
          }
	  case ';' :
 	  {
            if (strcmp(TmpChar, "") != 0)
  	      Number[NumberCount] = atoi(TmpChar);
	    NumberCount = NumberCount + 1;
	    if (NumberCount > 128)
              goto Abort;
	    CharCount = 0;
            EscPos = EscPos + 1;
            memset(TmpChar, NULL, 5);
            break;
	  }
	  default :
	  {
	    if (CharCount > 3)
	      goto Abort;
	    else
	    {
	      TmpChar[CharCount] = DataIn[EscPos];
	      EscPos = EscPos + 1;
              CharCount = CharCount + 1;
	    }
            break;
          }
        }
      }
      if (strcmp(TmpChar, "") != 0)
      {
	Number[NumberCount] = atoi(TmpChar);
	NumberCount = NumberCount + 1;
	if (NumberCount > 127)
          goto Abort;
	CharCount = 0;
        memset(TmpChar, NULL, 5);
      }

      // Decipher ANSI Command and Process Them
      switch (DataIn[EscPos])
      {
        case 'H' :
        case 'f' :
        {
          y = Number[0];
	  x = Number[1] + 1;
          i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
        case 'A' :
        {
          y = y - Number[0];
          if (y < 0)
            y = 0;
	  i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
	case 'B' :
        {  
          y = y + Number[0];
          if (y > 30)
            y = 30;
	  i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
        case 'C' :
        {
          x = x + Number[0];
          if (x > 80)
            x = 80;
	  i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
        case 'D' :
        {
          x = x - Number[0];
          if (x < 0)
	    x = 0;
	  i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
	case 's' :
        {
	  SavedX = x;
          SavedY = y;
	  i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
	case 'u' :
        {
	  x = SavedX;
          y = SavedY;
	  i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
	case 'J' :
        {
	  if (Number[0] == 2)
          {
	    HBRUSH hBrush, hBrushOld;
	    hBrush = GetStockObject(BLACK_BRUSH);
            hBrushOld = SelectObject(ghDC, hBrush);
	    if (Number[0] == '2')
              Rectangle(ghDC, 0, 0, 640, 360); 
	    hBrush = SelectObject(ghDC, hBrushOld);
	    DeleteObject(hBrush);
            DeleteObject(hBrushOld);
	    x = 0;
            y = 0;
	  }
	  i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
	case 'K' :
        {
	  HBRUSH hBrush, hBrushOld;
	  hBrush = GetStockObject(BLACK_BRUSH);
          hBrushOld = SelectObject(ghDC, hBrush);
	  Rectangle(ghDC, 0, y*12, 640, (y+1)*12-1);
	  hBrush = SelectObject(ghDC, hBrushOld);
	  DeleteObject(hBrush);
          DeleteObject(hBrushOld);
	  i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
	case 'h' :
        {
	  if (Number[0] == 7)
          {
            at.LineWrapFlag = TRUE;
	  }
/*	  if (Number[0] == '6')
	  {

	  }*/
	  i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
	case '!' :
	{
          // RIPscrip Specific
	  if (((Number[0] == 0) || (NumberCount == 0)) && (RipAutoSense == TRUE))
          {
            // Query RIPscrip Version Number
            HDDEDATA ghData;
	    char RIPscripVersion[30];
	    memset(RIPscripVersion, NULL, 30);
	    strcpy(RIPscripVersion, "RIPSCRIP010000");
	    ghData = DdeCreateDataHandle(idInst, RIPscripVersion, strlen(RIPscripVersion), 0L, hszItem, CF_TEXT, 0);
	    DdeClientTransaction(ghData, -1, hConv, hszItem, CF_TEXT, XTYP_POKE, 30, &result);
	  }
	  if (Number[0] == 1)
	  {
            // Disable RIPscrip Processing
	    RipProcessing = FALSE;
	  }
	  if (Number[0] == 2)
	  {
            // Enable RIPscrip Processing
	    RipProcessing = TRUE;
	  }
	  if (Number[0] == 3)
	  {
	    // Query AnsiRipZmodemWindow Version Number
	    char RIPscripVersion[30];
	    HDDEDATA ghData;
	    memset(RIPscripVersion, NULL, 30);
	    strcpy(RIPscripVersion, "ANSIRIPZ010010");
	    ghData = DdeCreateDataHandle(idInst, RIPscripVersion, strlen(RIPscripVersion), 0L, hszItem, CF_TEXT, 0);
	    DdeClientTransaction(ghData, -1, hConv, hszItem, CF_TEXT, XTYP_POKE, 30, &result);
	  }
	  if (Number[0] == 4)
	  {
	    // Enable TrueBrown
	    at.TrueBrown = TRUE;
	  }
	  if (Number[0] == 5)
	  {
	    // Disable TrueBrown
	    at.TrueBrown = FALSE;
	  }
	  if (Number[0] == 6)
	  {
	    // Enable KittyCat! Comm
	  }
	  i = EscPos;
	  BeginPos = i + 1;
	}
	case 'n' :
        {
	  if ((Number[0] == 6) && (BbsYN == TRUE) && (AnsiAutoSense == TRUE))
	  {
	    HDDEDATA ghData;
	    char QueryAnsi[30];
	    char TmpStr[5];
	    memset(TmpStr, NULL, 5);
	    memset(QueryAnsi, NULL, 30);
            QueryAnsi[0] = 27;
	    strcat(QueryAnsi, "[");
	    gcvt(y, 5, TmpStr);
	    strcat(QueryAnsi, TmpStr);
	    strcat(QueryAnsi, ";");
            memset(TmpStr, NULL, 5);
	    gcvt(x-1, 5, TmpStr);
	    strcat(QueryAnsi, TmpStr);
	    strcat(QueryAnsi, "R");
	    ghData = DdeCreateDataHandle(idInst, QueryAnsi, strlen(QueryAnsi), 0L, hszItem, CF_TEXT, 0);
	    DdeClientTransaction(ghData, -1, hConv, hszItem, CF_TEXT, XTYP_POKE, 30, &result);
	  }
	  i = EscPos;
	  BeginPos = i + 1;
	  break;
        }
	case 'm' :
        {
	  int t = 0;
	  while (t < NumberCount)
	  {
	    switch (Number[t])
	    {
	      case 0 :
	      {
                // All Attributes Off
		at.UnderlineFlag = FALSE;
		at.BoldFlag = FALSE;
		at.BlinkFlag = FALSE;
		at.ReverseFlag = FALSE;
		at.ConcealedFlag = FALSE;
		at.ForegroundNum = ForegroundDefault;
		at.BackgroundNum = BackgroundDefault;
		break;
              }
	      case 1 :
	      {
                // Bold
		if (at.BoldFlag == FALSE)
		{
		  at.BoldFlag = TRUE;
		  if (at.ForegroundNum <= 8)
                    at.ForegroundNum = at.ForegroundNum + 8;
		}
                break;
              }
	      case 4 :
	      {
                // Underscore
                at.UnderlineFlag = TRUE;
		break;
              }
	      case 5 :
	      {
		// Blink
                at.BlinkFlag = TRUE;
                break;
              }
	      case 7 :
	      {
		// Reverse
                at.ReverseFlag = TRUE;
                break;
              }
	      case 8 :
	      {
		// Conceal
                at.ConcealedFlag = TRUE;
                break;
              }
	      case 30 :
	      {
		// Black FG
		if (at.BoldFlag == FALSE)
		  at.ForegroundNum = 1;
		else
		  at.ForegroundNum = 9;
		break;
              }
	      case 31 :
	      {
                // Red FG
		if (at.BoldFlag == FALSE)
		  at.ForegroundNum = 2;
		else
		  at.ForegroundNum = 10;
		break;
              }
	      case 32 :
	      {
                // Green FG
		if (at.BoldFlag == FALSE)
		  at.ForegroundNum = 3;
		else
		  at.ForegroundNum = 11;
		break;
              }
	      case 33 :
	      {
                // Brown/Yellow FG
		if (at.BoldFlag == FALSE)
		  at.ForegroundNum = 4;
		else
		  at.ForegroundNum = 12;
		break;
              }
	      case 34 :
	      {
                // Blue FG
		if (at.BoldFlag == FALSE)
		  at.ForegroundNum = 5;
		else
		  at.ForegroundNum = 13;
		break;
              }
	      case 35 :
	      {
                // Magenta FG
		if (at.BoldFlag == FALSE)
		  at.ForegroundNum = 6;
 		else
 		  at.ForegroundNum = 14;
 		break;
              }
	      case 36 :
	      {
                // Cyan FG
		if (at.BoldFlag == FALSE)
		  at.ForegroundNum = 7;
 		else
 		  at.ForegroundNum = 15;
 		break;
              }
	      case 37 :
	      {
                // White FG
		if (at.BoldFlag == FALSE)
		  at.ForegroundNum = 8;
 		else
 		  at.ForegroundNum = 16;
 		break;
              }
	      case 40 :
	      {
                // Black BG
		at.BackgroundNum = 1;
		break;
              }
	      case 41 :
	      {
                // Red BG
		at.BackgroundNum = 2;
		break;
              }
	      case 42 :
	      {
                // Green BG
		at.BackgroundNum = 3;
		break;
              }
	      case 43 :
	      {
                // Yellow BG
		at.BackgroundNum = 4;
		break;
              }
	      case 44 :
	      {
                // Blue BG
		at.BackgroundNum = 5;
		break;
              }
	      case 45 :
	      {
                // Magenta BG
		at.BackgroundNum = 6;
		break;
              }
	      case 46 :
	      {
                // Cyan BG
		at.BackgroundNum = 7;
		break;
              }
	      case 47 :
	      {
                // White BG
		at.BackgroundNum = 8;
		break;
	      }
	    }
            t = t + 1;
	  }
	  i = EscPos;
  	  BeginPos = i + 1;
	  break;
        }
      }
    }
    Abort:
    ReadFlag = FALSE;
  }
  if (BeginPos != DataInLen - 1)
    WriteStringToScreen(DataIn, BeginPos, DataInLen);
 }
 else
 {
  WriteStringToScreen(DataIn, 0, DataInLen);
 }
}

#pragma argsused
void WMCommand_Handler(HWND hWnd, int id, HWND hwndCtl, UINT codeNotify)
{
  switch (id)
  {
    case 100 :
    {
      // Hangup
      if (IsZoomed(hWnd) == FALSE)
      {
        RECT rect;
        GetWindowRect(hWnd, &rect);
        WritePrivateProfileInteger("Window", "XPos", rect.left, "ANSIRIPZ.INI"),
        WritePrivateProfileInteger("Window", "YPos", rect.top, "ANSIRIPZ.INI"),
        WritePrivateProfileInteger("Window", "Width", rect.right - rect.left, "ANSIRIPZ.INI");
	WritePrivateProfileInteger("Window", "Height", rect.bottom - rect.top, "ANSIRIPZ.INI");
      }
      if (BbsYN == TRUE)
      {
	char SendString[10];
	HDDEDATA HangupData;
	memset(SendString, NULL, 10);
        strcpy(SendString, "hangup");
	HangupData = DdeCreateDataHandle(idInst, SendString, 10, 0L, hszModifyItem, CF_TEXT, 0);
	DdeClientTransaction((LPBYTE) HangupData, -1, hConv, hszModifyItem, CF_TEXT, XTYP_POKE, 10, &result);
	DestroyWindow(ghWnd);
      }
      break;
    }
    case 101 :
    {
      // Window Settings
      DLGPROC AbtDlgProc;
      AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)ConfigDlgProc, ghInstance);
      DialogBox(ghInstance, "CONFIG", hWnd, AbtDlgProc);
      FreeProcInstance((FARPROC)AbtDlgProc);
      break;
    }
    case 102 :
    {
      // Upload
      DLGPROC AbtDlgProc;
      AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)ZModemDlgProc, ghInstance);
      DialogBoxParam(ghInstance, "ZMODEM", hWnd, AbtDlgProc, (LPARAM) 1);
      FreeProcInstance((FARPROC)AbtDlgProc);
      break;
    }
    case 103 :
    {
      // Download
      DLGPROC AbtDlgProc;
      AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)ZModemDlgProc, ghInstance);
      DialogBoxParam(ghInstance, "ZMODEM", hWnd, AbtDlgProc, (LPARAM) 2);
      FreeProcInstance((FARPROC)AbtDlgProc);
      break;
    }
    case 104 :
    {
      // About
      DLGPROC AbtDlgProc;
      AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)AboutDlgProc, ghInstance);
      DialogBox(ghInstance, "ABOUT", hWnd, AbtDlgProc);
      FreeProcInstance((FARPROC)AbtDlgProc);
      break;
    }
    case 105 :
    {
      // Open File
      char *DialogText = "Open ANSI/RIPscrip File";
      char DefaultText[288];
      LPSTR FileString = "ANSI/RIPscript\0*.txt;*.ans;*.rip\0All Files\0*.*\0\0";
      DWORD MustExist = TRUE;

      /* Common-Dialog Routine */
      char WorkStr[144];
      OPENFILENAME ofn;
      char File[144];
      char Dir[144];
      memset(DefaultText, NULL, 288);
      memset(WorkStr, NULL, 288);
      memset(File, NULL, 288);
      memset(Dir, NULL, 288);
      strcpy(DefaultText, FileOpened);
      if (strcmp(DefaultText, "") == 0)
      {
        Dir[0] = '\0';
        File[0] = '\0';
        DefaultText[0] = '\0';
      }
      else
      {
	int i, t, s;
	strrev(DefaultText);
	for (i=0;i<=strlen(DefaultText);i++)
	{
	  if (DefaultText[i] == '\\')
	  {
	    t = i+1;
	    File[i] = '\0';
            goto GetDir;
	  }
	  if (DefaultText[i] == ':')
	  {
	    t = i+1;
	    File[i] = '\0';
            goto GetDir;
          }
          else
          {
            File[i] = DefaultText[i];
          }
        }
        GetDir:
        for (s=t;s<=strlen(DefaultText);s++)
        {
          Dir[s-t] = DefaultText[s];
        }
        Dir[strlen(DefaultText)-t] = '\0';
        strrev(Dir);
        strrev(File);
        strrev(DefaultText);
      }
      memset(&ofn, 0, sizeof(OPENFILENAME));
      ofn.hInstance = ghInstance;
      ofn.lStructSize = sizeof(OPENFILENAME);
      ofn.hwndOwner = hWnd;
      ofn.lpstrFilter = FileString;
      ofn.lpstrFile = File;
      ofn.nMaxFile = 144;
      ofn.lpstrFileTitle = WorkStr;
      ofn.nMaxFileTitle = 144;
      ofn.lpstrInitialDir = Dir;
      ofn.lpstrDefExt = "txt";
      if (MustExist == TRUE)
      {
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
      }
      else
      {
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
      }
      ofn.lpstrTitle = DialogText; 
      if (!GetOpenFileName(&ofn))
      {
	strcpy(WorkStr, DefaultText);
      }
      else
      {
        strcpy(WorkStr, ofn.lpstrFile);
      }
	
      /* Open File and Read It */
      if( strcmp(FileOpened, WorkStr) != 0)
      {
	HFILE hFile;
        OFSTRUCT os;
	memset(&os, NULL, sizeof(&os));
	memset(FileOpened, NULL, 288);
        strcpy(FileOpened, WorkStr);
	hFile = OpenFile(FileOpened, &os, OF_READ);
	if (hFile == HFILE_ERROR)
	{
	  MessageBeep(MB_ICONEXCLAMATION);
	  MessageBox(hWnd, "Cannot open this file!", FileOpened, MB_OK | MB_ICONEXCLAMATION);
          memset(FileOpened, NULL, 288);
	}
	else
	{
	  char DataIn[2050];
	  int BytesRead;
          long PosSave;
	  if (BbsYN == FALSE)
	    SetWindowText(hWnd, FileOpened);
	  do
	  {
	    memset(DataIn, NULL, 2050);
	    PosSave = _llseek(hFile, 0, 1);
	    if (_llseek(hFile, 0, 2) == PosSave)
              goto EndThis;
	    else
	      _llseek(hFile, PosSave, 0);
	    BytesRead = _lread(hFile, DataIn, 2040);
	    if (BytesRead == HFILE_ERROR)
	      goto EndThis;
	    if (BytesRead > 0)
            {
	      ProcessAnsi(DataIn);
	      if (BbsYN == TRUE)
              {
		HDDEDATA ghData;
		ghData = DdeCreateDataHandle(idInst, DataIn, strlen(DataIn), 0L, hszItem, CF_TEXT, 0);
		DdeClientTransaction(ghData, -1, hConv, hszItem, CF_TEXT, XTYP_POKE, 2048, &result);
	      }
	    }
	  }
	  while (BytesRead == 2040);
	  EndThis:
	  _lclose(hFile);

	  /* Temporary */
	  memset(FileOpened, NULL, 288);
	}
      }
      break;
    }
    case 106 :
    {
      // Exit
      if (IsZoomed(hWnd) == FALSE)
      {
        RECT rect;
        GetWindowRect(hWnd, &rect);
        WritePrivateProfileInteger("Window", "XPos", rect.left, "ANSIRIPZ.INI"),
        WritePrivateProfileInteger("Window", "YPos", rect.top, "ANSIRIPZ.INI"),
        WritePrivateProfileInteger("Window", "Width", rect.right - rect.left, "ANSIRIPZ.INI");
	WritePrivateProfileInteger("Window", "Height", rect.bottom - rect.top, "ANSIRIPZ.INI");
      }
      if (BbsYN == FALSE)
	DestroyWindow(hWnd);
      break;
    }
    case 107 :
    {
      // Default Size
      if (IsZoomed(hWnd) == FALSE)
      {
        RECT rect;
        GetWindowRect(hWnd, &rect);
	SetWindowPos(hWnd, NULL, rect.left, rect.top, 657, 419, SWP_NOZORDER | SWP_NOACTIVATE);
      }
    }
  }
}

#pragma argsused
BOOL CALLBACK _export AboutDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
  switch(message)
  {
    case WM_INITDIALOG :
    {
      return TRUE;
    }
    case WM_COMMAND :
    {
      if ((wParam == 1) || (wParam == 2))
      {
	EndDialog(hDlg, 0);
        return 0;
      }
    }
  }
  return FALSE;
}

#pragma argsused
BOOL CALLBACK _export ConfigDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
  switch(message)
  {
    case WM_INITDIALOG :
    {
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Black");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Red");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Green");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Brown/Yellow");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Blue");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Magenta");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Cyan");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Light Gray");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Gray");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Red");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Green");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Yellow");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Blue");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Magenta");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Cyan");
      SendDlgItemMessage(hDlg, 307, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "White");
      SendDlgItemMessage(hDlg, 308, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Black");
      SendDlgItemMessage(hDlg, 308, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Red");
      SendDlgItemMessage(hDlg, 308, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Green");
      SendDlgItemMessage(hDlg, 308, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Brown/Yellow");
      SendDlgItemMessage(hDlg, 308, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Blue");
      SendDlgItemMessage(hDlg, 308, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Magenta");
      SendDlgItemMessage(hDlg, 308, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Dark Cyan");
      SendDlgItemMessage(hDlg, 308, CB_ADDSTRING, 0, (LPARAM) (LPCSTR) "Light Gray");
      SendDlgItemMessage(hDlg, 307, CB_SETCURSEL, at.ForegroundNum - 1, 0L);
      SendDlgItemMessage(hDlg, 308, CB_SETCURSEL, at.BackgroundNum - 1, 0L);
      SendDlgItemMessage(hDlg, 306, BM_SETCHECK, (WPARAM) RipProcessing, 0L);
      SendDlgItemMessage(hDlg, 305, BM_SETCHECK, (WPARAM) RipAutoSense, 0L);
      SendDlgItemMessage(hDlg, 310, BM_SETCHECK, (WPARAM) AnsiEnable, 0L);
      SendDlgItemMessage(hDlg, 312, BM_SETCHECK, (WPARAM) AnsiAutoSense, 0L);
      SendDlgItemMessage(hDlg, 311, BM_SETCHECK, (WPARAM) at.TrueBrown, 0L);
      SendDlgItemMessage(hDlg, 309, BM_SETCHECK, (WPARAM) UserDefault, 0L);
      sat.ForegroundNum = at.ForegroundNum;
      sat.BackgroundNum = at.BackgroundNum;
      sat.TrueBrown = at.TrueBrown;
      return TRUE;
    }
    case WM_MEASUREITEM :
    {
      LPMEASUREITEMSTRUCT lpmis1;
      lpmis1 = (MEASUREITEMSTRUCT FAR*) lParam;
      lpmis1 = InitButton(lpmis1, 313, 230, 190);
      return TRUE;
    }
    case WM_DRAWITEM :
    {
      LPDRAWITEMSTRUCT lpdis;
      lpdis = (DRAWITEMSTRUCT FAR*) lParam;
      RefreshPicPal(hDlg, hPal);
      if (lpdis->CtlID == 313)
      {
	if (lpdis->itemAction == ODA_DRAWENTIRE)
	{
          HPALETTE hOldPal;
	  HBRUSH hBrush;
	  char SampleStr[15];
	  memset(SampleStr, NULL, 15);
          strcpy(SampleStr, "Sample Text");
	  hOldPal = SelectPalette(lpdis->hDC, hPal, FALSE);
	  hBrush = CreateSolidBrush(GetIndexColor(sat.BackgroundNum, sat.TrueBrown));
          FillRect(lpdis->hDC, &lpdis->rcItem, hBrush); 
	  SetTextColor(lpdis->hDC, GetIndexColor(sat.ForegroundNum, sat.TrueBrown));
	  DrawText(lpdis->hDC, SampleStr, strlen(SampleStr), &lpdis->rcItem, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
	  SelectPalette(lpdis->hDC, hOldPal, FALSE);
  	  DeleteObject(hOldPal);
	  DeleteObject(hBrush);
	}
      }
      return TRUE;
    }
    case WM_COMMAND :
    {
      if (wParam == 1)
      {
	RipProcessing = SendDlgItemMessage(hDlg, 306, BM_GETCHECK, 0, 0L);
	RipAutoSense = SendDlgItemMessage(hDlg, 305, BM_GETCHECK, 0, 0L);
	AnsiEnable = SendDlgItemMessage(hDlg, 310, BM_GETCHECK, 0, 0L);
	AnsiAutoSense = SendDlgItemMessage(hDlg, 312, BM_GETCHECK, 0, 0L);
	at.TrueBrown = SendDlgItemMessage(hDlg, 311, BM_GETCHECK, 0, 0L);
	UserDefault = SendDlgItemMessage(hDlg, 309, BM_GETCHECK, 0, 0L);
	at.BackgroundNum = SendDlgItemMessage(hDlg, 308, CB_GETCURSEL, 0, 0L) + 1;
	at.ForegroundNum = SendDlgItemMessage(hDlg, 307, CB_GETCURSEL, 0, 0L) + 1;
	WritePrivateProfileInteger("RIPscrip", "ProcessingFlag", RipProcessing, "ANSIRIPZ.INI");
	WritePrivateProfileInteger("RIPscrip", "AutoSensingEnable", RipAutoSense, "ANSIRIPZ.INI");
	WritePrivateProfileInteger("ANSI", "ProcessingFlag", AnsiEnable, "ANSIRIPZ.INI");
	WritePrivateProfileInteger("ANSI", "AutoSensingFlag", AnsiAutoSense, "ANSIRIPZ.INI");
	WritePrivateProfileInteger("ANSI", "TrueBrown", at.TrueBrown, "ANSIRIPZ.INI");
        WritePrivateProfileInteger("ANSI", "UseColorAsDefault", UserDefault, "ANSIRIPZ.INI");
	if (UserDefault == 1)
	{
	  BackgroundDefault = at.BackgroundNum;
	  ForegroundDefault = at.ForegroundNum;
	  WritePrivateProfileInteger("ANSI", "Foreground", at.ForegroundNum, "ANSIRIPZ.INI");
	  WritePrivateProfileInteger("ANSI", "Background", at.BackgroundNum, "ANSIRIPZ.INI");
	}
	if (UserDefault == 0)
	{
	  BackgroundDefault = 1;
	  ForegroundDefault = 8;
	}
	EndDialog(hDlg, 0);
	return 0;
      }
      if (wParam == 2)
      {
	EndDialog(hDlg, 0);
        return 0;
      }
      if (wParam == 311)
      {
	if (HIWORD(lParam) == BN_CLICKED)
	{
	  sat.TrueBrown = SendDlgItemMessage(hDlg, 311, BM_GETCHECK, 0, 0L);
	  InvalidateRect(GetDlgItem(hDlg, 313), NULL, FALSE);
	}
      }
      if ((wParam == 307) || (wParam == 308))
      {
	if (HIWORD(lParam) == CBN_SELCHANGE)
        {
	  sat.BackgroundNum = SendDlgItemMessage(hDlg, 308, CB_GETCURSEL, 0, 0L) + 1;
	  sat.ForegroundNum = SendDlgItemMessage(hDlg, 307, CB_GETCURSEL, 0, 0L) + 1;
	  InvalidateRect(GetDlgItem(hDlg, 313), NULL, FALSE);
	}
      }
    }
  }
  return FALSE;
}

#pragma argsused
BOOL CALLBACK _export ZModemDlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
  switch(message)
  {
    case WM_INITDIALOG :
    {
      if (lParam == 1)
      {
        // Upload
	SetWindowText(hDlg, "ZModem Upload - Initializing");
      }
      if (lParam == 2)
      {
	// Download
        SetWindowText(hDlg, "ZModem Download - Initializing");
      }
      return TRUE;
    }
    case WM_COMMAND :
    {
      if (wParam == 2)
      {
	EndDialog(hDlg, 0);
        return 0;
      }
    }
  }
  return FALSE;
}

COLORREF GetIndexColor(int Num, int TrueBrown)
{
  COLORREF NewColor;
  switch (Num)
  {
    case 1 : {  NewColor = Black;  break;  }
    case 2 : {  NewColor = Red;  break;  }
    case 3 : {  NewColor = Green;  break;  }
    case 4 :
    {
      if (TrueBrown == FALSE)
	NewColor = Yellow;
      else
	NewColor = Brown;
      break;
    }
    case 5 : {  NewColor = Blue;  break;  }
    case 6 : {  NewColor = Magenta;  break;  }
    case 7 : {  NewColor = Cyan;  break;  }
    case 8 : {  NewColor = White;  break;  }
    case 9 : {  NewColor = LightBlack;  break;  }
    case 10 : {  NewColor = LightRed;  break;  }
    case 11 : {  NewColor = LightGreen;  break;  }
    case 12 : {  NewColor = LightYellow;  break;  }
    case 13 : {  NewColor = LightBlue;  break;  }
    case 14 : {  NewColor = LightMagenta;  break;  }
    case 15 : {  NewColor = LightCyan;  break;  }
    case 16 : {  NewColor = LightWhite;  break;  }
    default : {  NewColor = White; break;  }
  }
  return NewColor;
}

BOOL WritePrivateProfileInteger(LPCSTR lpszSection, LPCSTR lpszEntry, int Number, LPCSTR lpszFileName)
{
  char TmpStr[10];
  memset(TmpStr, NULL, 10);
  gcvt(Number, 5, TmpStr);
  return WritePrivateProfileString(lpszSection, lpszEntry, (LPCSTR) TmpStr, lpszFileName);
}

LPMEASUREITEMSTRUCT FAR PASCAL _export InitButton(LPMEASUREITEMSTRUCT lpmis, int ID, int X, int Y)
{
  lpmis->CtlType = ODT_BUTTON;
  lpmis->CtlID = ID;
  lpmis->itemID = NULL;
  lpmis->itemWidth = X;
  lpmis->itemHeight = Y;
  lpmis->itemData = NULL;
  return lpmis;
}

void FAR PASCAL _export RefreshPicPal(HWND hWnd, HPALETTE hNewPalette)
{
  if (hNewPalette)
  {
    HPALETTE hOldPalette;
    HDC hDC = GetDC(hWnd);
    hOldPalette = SelectPalette(hDC,hNewPalette,FALSE);
    RealizePalette(hDC);
    SelectPalette(hDC,hOldPalette,FALSE);
    ReleaseDC(hWnd,hDC);
    DeleteObject(hOldPalette);
  }
}

int GetRipNumber(char Number1, char Number2)
{
  int Number;
  if ((Number2 <= '9') && (Number2 >= '0'))
    Number = (int) Number2 - '0';
  else
    Number = (int) Number2 - 55;
  if ((Number1 <= '9') && (Number1 >= '0'))
    Number = (int) Number + (10 * (Number1 - '0'));
  else
    Number = (int) Number + (10 * (Number1 - 55));
  return Number;
}
