// KittyDDE Monitor
// by Steven Lawrance

#include <windowsx.h>
#include <stdlib.h>
#include <string.h>
#include <ddeml.h>
#include "Structs.h"

#define  MAXERROR 10

DWORD	idInst;
FARPROC DdeCallBackProc;
STRING  Errors[MAXERROR];
STRING  Transactions[MAXERROR];
int	NumberOfTransactions;
int	NumberOfErrors;
int	NumberOfConnections;

HDDEDATA FAR PASCAL _export DdeCallBack(UINT iType, UINT iFmt, HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD Data1, DWORD Data2);

#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdParam, int nCmdShow)
{
  NumberOfErrors = 0;
  NumberOfConnections = 0;
  DdeCallBackProc = MakeProcInstance((FARPROC) DdeCallBack, hInstance);
  DdeInitialize(&idInst, (PFNCALLBACK) DdeCallBackProc, APPCLASS_MONITOR | MF_CALLBACKS | MF_ERRORS | MF_CONV, 0);
  MessageBox(HWND_DESKTOP, "Press [Ok] to exit the KittyDDE Monitor.", "KittyDDE Monitor", MB_OK | MB_ICONASTERISK);
  DdeUninitialize(idInst);
  FreeProcInstance((FARPROC) DdeCallBackProc);
  if ((NumberOfErrors != 0) || (NumberOfConnections != 0) || (NumberOfTransactions != 0))
  {
    char Report[2000];
    char TmpStr[10];
    int i;
    memset(Report, NULL, 2000);
    memset(TmpStr, NULL, 10);
    strcpy(Report, "Number of errors: ");
    gcvt(NumberOfErrors, 8, TmpStr);
    strcat(Report, TmpStr);
    strcat(Report, "\nNumber of connections: ");
    memset(TmpStr, NULL, 10);
    gcvt(NumberOfConnections, 8, TmpStr);
    strcat(Report, TmpStr);
    strcat(Report, "\nNumber of transactions: ");
    memset(TmpStr, NULL, 10);
    gcvt(NumberOfTransactions, 8, TmpStr);
    strcat(Report, TmpStr);
    if (NumberOfErrors > 0)
    {
      strcat(Report, "\n\nError list:");
      if (NumberOfErrors > 9)
        NumberOfErrors = 9;
      for (i = 0; i <= NumberOfErrors - 1; i++)
      {
	strcat(Report, "\n");
	strcat(Report, Errors[i].String);
      }
    }
    if (NumberOfTransactions > 0)
    {
      strcat(Report, "\n\nTransaction list:");
      if (NumberOfTransactions > 9)
        NumberOfTransactions = 9;
      for (i = 0; i <= NumberOfTransactions - 1; i++)
      {
	strcat(Report, "\n");
	strcat(Report, Transactions[i].String);
      }
    }
    MessageBox(HWND_DESKTOP, Report, "KittyDDE Report", MB_OK | MB_ICONASTERISK);
  }
  PostQuitMessage(0);
  return 0;
}

#pragma argsused
HDDEDATA FAR PASCAL _export DdeCallBack(UINT iType, UINT iFmt, HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD Data1, DWORD Data2)
{
  if (iType == XTYP_MONITOR)
  {
    switch (Data2)
    {
      case MF_ERRORS :
      {
	if (NumberOfErrors <= 9)
        {
	  MONERRSTRUCT es;
	  DdeGetData(hData, &es, sizeof(MONERRSTRUCT), NULL);
	  switch (es.wLastError)
	  {
	    case DMLERR_INVALIDPARAMETER    : { strcpy(Errors[NumberOfErrors].String, "Invalid parameter"); break; }
	    case DMLERR_NO_ERROR            : { strcpy(Errors[NumberOfErrors].String, "No error"); break; }
	    case DMLERR_DLL_USAGE           : { strcpy(Errors[NumberOfErrors].String, "DLL usage"); break; }
	    case DMLERR_SYS_ERROR           : { strcpy(Errors[NumberOfErrors].String, "System error"); break; }
	    case DMLERR_ADVACKTIMEOUT       : { strcpy(Errors[NumberOfErrors].String, "Adv ack timeout"); break; }
	    case DMLERR_BUSY                : { strcpy(Errors[NumberOfErrors].String, "Busy"); break; }
	    case DMLERR_DATAACKTIMEOUT      : { strcpy(Errors[NumberOfErrors].String, "Data ack timeout"); break; }
	    case DMLERR_EXECACKTIMEOUT      : { strcpy(Errors[NumberOfErrors].String, "Exec ack timeout"); break; }
	    case DMLERR_MEMORY_ERROR        : { strcpy(Errors[NumberOfErrors].String, "Memory error"); break; }
	    case DMLERR_NO_CONV_ESTABLISHED : { strcpy(Errors[NumberOfErrors].String, "No conv established"); break; }
	    case DMLERR_NOTPROCESSED        : { strcpy(Errors[NumberOfErrors].String, "Not processed"); break; }
	    case DMLERR_POKEACKTIMEOUT      : { strcpy(Errors[NumberOfErrors].String, "Poke ack timeout"); break; }
	    case DMLERR_POSTMSG_FAILED      : { strcpy(Errors[NumberOfErrors].String, "Post message failed"); break; }
	    case DMLERR_REENTRANCY          : { strcpy(Errors[NumberOfErrors].String, "Re-entrancy"); break; }
	    case DMLERR_SERVER_DIED         : { strcpy(Errors[NumberOfErrors].String, "Server died"); break; }
	    case DMLERR_UNADVACKTIMEOUT     : { strcpy(Errors[NumberOfErrors].String, "Unadv ack timeout"); break; }
	  }
	}
        NumberOfErrors = NumberOfErrors + 1;
        MessageBeep(MB_ICONSTOP);
        break;
      }
      case MF_CALLBACKS :
      {
	if (NumberOfTransactions <= 9)
        {
  	  MONCBSTRUCT es;
	  DdeGetData(hData, &es, sizeof(MONCBSTRUCT), NULL);
	  if (es.hData != NULL)
          {
	    char TmpStr2[50];
	    memset(TmpStr2, NULL, 50);
	    DdeGetData(es.hData, TmpStr2, 48, 0);
	    strcpy(Transactions[NumberOfTransactions].String, TmpStr2);
	    NumberOfTransactions = NumberOfTransactions + 1;
	  }
	}
	break;
      }
      case MF_CONV :
      {
        NumberOfConnections = NumberOfConnections + 1;
        MessageBeep(MB_ICONASTERISK);
	break;
      }
    }
  }
  return ((HDDEDATA) 0);
}
