// KittyCat! Comm 1.0 for Windows 3.1
// by Steven Lawrance
// ---Configuration File---

#include <windowsx.h>
#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "Structs.h"
#include "Userintr.h"
#include "Resource.h"

// Global Variables
HINSTANCE dllInstance;

/***********************************/

// DLL Routines
HINSTANCE FAR PASCAL _export Config_GetDLLInstance(void);

// Result Message Dialog Routines
void FAR PASCAL _export ResultMessages(HWND hWnd);
BOOL CALLBACK _export ResultMsgDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void FAR PASCAL _export WMResultMsgDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify);

// Modem Config Dialog Box Routines
void FAR PASCAL _export ModemConfig(HWND hWnd);
BOOL CALLBACK _export ConfigModemDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void FAR PASCAL _export WMConfigModemDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify);

/************************************/

// DLL Routines
#pragma argsused
int FAR PASCAL LibMain (HINSTANCE hInstance, WORD wDataSeg, WORD wHeapSize, LPSTR lpszCmdLine)
{
  if (wHeapSize > 0)
    UnlockData(0);
  dllInstance = hInstance;
  return 1;
}

HINSTANCE FAR PASCAL _export Config_GetDLLInstance(void)
{
  return dllInstance;
}


// Result Message Dialog Routines
void FAR PASCAL _export ResultMessages(HWND hWnd)
{
  DLGPROC DlgProc;
  DlgProc = (DLGPROC)MakeProcInstance((FARPROC)ResultMsgDlgProc, dllInstance);
  DialogBox(Resource_GetDLLInstance(), "RESULTMSG", hWnd, DlgProc);
  FreeProcInstance((FARPROC)DlgProc);
}

#pragma argused
BOOL CALLBACK _export ResultMsgDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch(message)
  {
    case WM_INITDIALOG :
    {
      RESULT result;
      int i;
      for (i=300;i<=315;i++)
      {
        SendDlgItemMessage(hDlg, i, EM_LIMITTEXT, 50, NULL);
      }
      result = LoadResultTable(result);
      SetDlgItemText(hDlg, 300, result.Connect1200);
      SetDlgItemText(hDlg, 301, result.Connect2400);
      SetDlgItemText(hDlg, 302, result.Connect4800);
      SetDlgItemText(hDlg, 303, result.Connect9600);
      SetDlgItemText(hDlg, 304, result.Connect14400);
      SetDlgItemText(hDlg, 305, result.Connect19200);
      SetDlgItemText(hDlg, 306, result.Connect38400);
      SetDlgItemText(hDlg, 307, result.Connect57600);
      SetDlgItemText(hDlg, 308, result.Connect115200);
      SetDlgItemText(hDlg, 309, result.Connect256000);
      SetDlgItemText(hDlg, 310, result.NoConnect1);
      SetDlgItemText(hDlg, 311, result.NoConnect2);
      SetDlgItemText(hDlg, 312, result.NoConnect3);
      SetDlgItemText(hDlg, 313, result.NoConnect4);
      SetDlgItemText(hDlg, 314, result.NoConnect5);
      SetDlgItemText(hDlg, 315, result.NoConnect6);
      return TRUE;
    }
    case WM_COMMAND :
    {
      return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMResultMsgDlgCommand_Handler);
    }
  }
  return FALSE;
}

#pragma argsused
void FAR PASCAL _export WMResultMsgDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
  switch(id)
  {
    case 1 :
    {
      RESULT result;
      GetDlgItemText(hDlg, 300, result.Connect1200, 50);
      GetDlgItemText(hDlg, 301, result.Connect2400, 50);
      GetDlgItemText(hDlg, 302, result.Connect4800, 50);
      GetDlgItemText(hDlg, 303, result.Connect9600, 50);
      GetDlgItemText(hDlg, 304, result.Connect14400, 50);
      GetDlgItemText(hDlg, 305, result.Connect19200, 50);
      GetDlgItemText(hDlg, 306, result.Connect38400, 50);
      GetDlgItemText(hDlg, 307, result.Connect57600, 50);
      GetDlgItemText(hDlg, 308, result.Connect115200, 50);
      GetDlgItemText(hDlg, 309, result.Connect256000, 50);
      GetDlgItemText(hDlg, 310, result.NoConnect1, 50);
      GetDlgItemText(hDlg, 311, result.NoConnect2, 50);
      GetDlgItemText(hDlg, 312, result.NoConnect3, 50);
      GetDlgItemText(hDlg, 313, result.NoConnect4, 50);
      GetDlgItemText(hDlg, 314, result.NoConnect5, 50);
      GetDlgItemText(hDlg, 315, result.NoConnect6, 50);
      SaveResultTable(result);
      EndDialog(hDlg, 0);
      break;
    }
    case 2 :
    {
      EndDialog(hDlg, 0);
      break;
    }
  }
}


// Modem Config Dialog Box Routines
void FAR PASCAL _export ModemConfig(HWND hWnd)
{
  DLGPROC DlgProc;
  DlgProc = (DLGPROC)MakeProcInstance((FARPROC)ConfigModemDlgProc, dllInstance);
  DialogBox(Resource_GetDLLInstance(), "COMMCONFIG", hWnd, DlgProc);
  FreeProcInstance((FARPROC)DlgProc);
}

#pragma argused
BOOL CALLBACK _export ConfigModemDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch(message)
  {
    case WM_INITDIALOG :
    {
      int i;
      char WorkStr[10];
      DATASTRUCT ds;
      ds = LoadDefaultStruct(ds);
      for (i=300;i<=309;i++)
      {
	GetDlgItemText(hDlg, i, WorkStr, 10);
	if (atol(WorkStr) == ds.CommSpeed)
	{
	  SendDlgItemMessage(hDlg, i, BM_SETCHECK, TRUE, NULL);
	}
      }
      for (i=310;i<=313;i++)
      {
        GetDlgItemText(hDlg, i, WorkStr, 3);
	if (WorkStr[0] == ds.CommParity[0])
	{
	  SendDlgItemMessage(hDlg, i, BM_SETCHECK, TRUE, NULL);
	}
      }
      for (i=314;i<=316;i++)
      {
        GetDlgItemText(hDlg, i, WorkStr, 5); 
	if (atof(WorkStr) == ds.CommStopBits)
	{
	  SendDlgItemMessage(hDlg, i, BM_SETCHECK, TRUE, NULL);
	}
      }
      SetDlgItemInt(hDlg, 317, ds.CommByteSize, FALSE);
      for (i=0-1;i<=3;i++)
      {
        if (ds.Volume == i)
	{
	  SendDlgItemMessage(hDlg, i + 321, BM_SETCHECK, TRUE, NULL);
	}
      }
      SendDlgItemMessage(hDlg, 325, BM_SETCHECK, ds.CommEC, NULL);
      SendDlgItemMessage(hDlg, 326, EM_LIMITTEXT, 100, NULL);
      SendDlgItemMessage(hDlg, 327, EM_LIMITTEXT, 50, NULL);
      SendDlgItemMessage(hDlg, 328, EM_LIMITTEXT, 50, NULL);
      SendDlgItemMessage(hDlg, 329, EM_LIMITTEXT, 50, NULL);
      SetDlgItemText(hDlg, 326, ds.InitString);
      SetDlgItemText(hDlg, 327, ds.DialPrefix);
      SetDlgItemText(hDlg, 328, ds.DialSuffix);
      SetDlgItemText(hDlg, 329, ds.HangupString);
      for (i=330;i<=337;i++)
      {
	WorkStr[0] = ds.CommPort[3];
	WorkStr[1] = '\0';
	if (GetDlgItemInt(hDlg, i, NULL, FALSE) == atoi(WorkStr))
	{
	  SendDlgItemMessage(hDlg, i, BM_SETCHECK, TRUE, NULL);
	}
      }
      return TRUE;
    }
    case WM_COMMAND :
    {
      return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMConfigModemDlgCommand_Handler);
    }
  }
  return FALSE;
}

#pragma argsused
void FAR PASCAL _export WMConfigModemDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
  switch(id)
  {
    case 1 :
    {
      int i;
      char WorkStr[10];
      DATASTRUCT ds;
      ds = LoadDefaultStruct(ds);
      for (i=300;i<=309;i++)
      {
	if (SendDlgItemMessage(hDlg, i, BM_GETCHECK, NULL, NULL) == 1)
        {
	  GetDlgItemText(hDlg, i, WorkStr, 10);
	  ds.CommSpeed = atol(WorkStr);
	}
      }
      for (i=310;i<=313;i++)
      {
	if (SendDlgItemMessage(hDlg, i, BM_GETCHECK, NULL, NULL) == 1)
        {
	  GetDlgItemText(hDlg, i, WorkStr, 10);
	  ds.CommParity[0] = WorkStr[0];
	  ds.CommParity[1] = '\0';
	}
      }
      for (i=314;i<=316;i++)
      {
	if (SendDlgItemMessage(hDlg, i, BM_GETCHECK, NULL, NULL) == 1)
        {
	  GetDlgItemText(hDlg, i, WorkStr, 5);
	  ds.CommStopBits = atof(WorkStr);
        }
      }
      ds.CommByteSize = GetDlgItemInt(hDlg, 317, NULL, FALSE);
      for (i=0-1;i<=3;i++)
      {
	if (SendDlgItemMessage(hDlg, i+321, BM_GETCHECK, NULL, NULL) == 1)
        {
	  ds.Volume = i;
	  gcvt(ds.Volume, 10, WorkStr);
	}
      }
      ds.CommEC = SendDlgItemMessage(hDlg, 325, BM_GETCHECK, NULL, NULL);
      GetDlgItemText(hDlg, 326, ds.InitString, 100);
      GetDlgItemText(hDlg, 327, ds.DialPrefix, 50);
      GetDlgItemText(hDlg, 328, ds.DialSuffix, 50);
      GetDlgItemText(hDlg, 329, ds.HangupString, 50);
      for (i=330;i<=337;i++)
      {
	if (SendDlgItemMessage(hDlg, i, BM_GETCHECK, NULL, NULL) == 1)
        {
	  GetDlgItemText(hDlg, i, WorkStr, 50);
	  strcpy(ds.CommPort, "COM");
          strcat(ds.CommPort, WorkStr);
	}
      }
      SaveDefaultStruct(ds);
      EndDialog(hDlg, 0);
      break;
    }
    case 2 :
    {
      EndDialog(hDlg, 0);
      break;
    }
  }
  if (codeNotify == EN_CHANGE)
  {
    if (id == 317)
    {
      int WorkInt;
      WorkInt = GetDlgItemInt(hDlg, 317, NULL, FALSE);
      if (WorkInt > 8)
      {
	Sound(MB_ICONEXCLAMATION);
        MessageBox(hDlg, "The Byte Length (In Bits) Must Be Between 4 And 8", "Byte Length Error", MB_OK | MB_ICONEXCLAMATION);
        SetDlgItemInt(hDlg, 317, 8, FALSE);
      }
      if (WorkInt == 0)
      {
	SetDlgItemInt(hDlg, 317, 4, FALSE);
	WorkInt = 4;
      }
      if (WorkInt < 4)
      {
	Sound(MB_ICONEXCLAMATION);
        MessageBox(hDlg, "The Byte Length (In Bits) Must Be Between 4 And 8", "Byte Length Error", MB_OK | MB_ICONEXCLAMATION);
        SetDlgItemInt(hDlg, 317, 4, FALSE);
      }
    }
  }
  if (codeNotify == BN_CLICKED)
  {
    if (id == 318)
    {
      int i;
      for (i=310;i<=316;i++)
      {
        SendDlgItemMessage(hDlg, i, BM_SETCHECK, FALSE, NULL);
      }
      SendDlgItemMessage(hDlg, 312, BM_SETCHECK, TRUE, NULL);
      SendDlgItemMessage(hDlg, 314, BM_SETCHECK, TRUE, NULL);
      SetDlgItemText(hDlg, 317, "8");
    }
    if (id == 319)
    {
      int i;
      for (i=310;i<=316;i++)
      {
        SendDlgItemMessage(hDlg, i, BM_SETCHECK, FALSE, NULL);
      }
      SendDlgItemMessage(hDlg, 310, BM_SETCHECK, TRUE, NULL);
      SendDlgItemMessage(hDlg, 314, BM_SETCHECK, TRUE, NULL);
      SetDlgItemText(hDlg, 317, "7");
    }
  }
}
