// CreateDesk 1.1 for Windows
// By Steven Lawrance

// This program creates a desk file so the Desktop program can read it

#include <windows.h>

#define FOLDER 1
#define ITEM 2
#define EXTENSION 4
#define LINK 16

UINT WriteFile(HFILE hFile, LPCSTR lpszString);
UINT WriteString(HFILE hFile, LPCSTR lpszString);
UINT WriteUINT(HFILE hFile, unsigned int Uint);
UINT WriteINT(HFILE hFile, int Uint);
UINT WriteULINT(HFILE hFile, unsigned long int Uint);

#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdParam, int nCmdShow)
{
  OFSTRUCT os;

  // Open the file and write a folder with an item in it and an item in the
  // desktop
  HFILE hFile = OpenFile("i:\\bc45\\programs\\kittycom\\kittycat.kcd", &os, OF_CREATE);
  if (hFile == HFILE_ERROR)
  {
	 MessageBox(HWND_DESKTOP, "Cannot open file!", "Error", MB_OK);
	 PostQuitMessage(0);
	 return 0;
  }

  // Header Info
  WriteFile(hFile, "KittyCat! Desktop 1.1 - Desk File");
  WriteString(hFile, "My Desktop!  :-)");

  // Icon and Index
  WriteString(hFile, "c:\\windows\\moricons.dll");
  WriteUINT(hFile, 3);

  // Window Position
  WriteINT(hFile, 5);
  WriteINT(hFile, 5);
  WriteINT(hFile, 225);
  WriteINT(hFile, 225);

  // Picture File
  WriteString(hFile, "c:\\windows\\arcade.bmp");

  // Item Data
  WriteULINT(hFile, 2);

  // Folder Item Data
  WriteUINT(hFile, FOLDER);

	 // Folder State
	 WriteUINT(hFile, TRUE);

	 // Folder Name
	 WriteString(hFile, "Steven's Folder");

	 // Icon and Index
	 WriteString(hFile, "c:\\windows\\moricons.dll");
	 WriteUINT(hFile, 10);

	 // Folder Position
	 WriteINT(hFile, 20);
	 WriteINT(hFile, 20);
	 WriteINT(hFile, 125);
	 WriteINT(hFile, 125);

	 // Icon Position
	 WriteINT(hFile, 20);
	 WriteINT(hFile, 20);

	 // Picture File
	 WriteString(hFile, "c:\\windows\\zigzag.bmp");

	 // Extenstion Data (none)
	 WriteUINT(hFile, 0);

	 // Item Data
	 WriteULINT(hFile, 1);

	 // Program Item Data
	 WriteUINT(hFile, ITEM);

		// Item Name
		WriteString(hFile, "KittyCat! Comm 1.0 for Windows");

		// Icon and Index
		WriteString(hFile, "c:\\windows\\moricons.dll");
		WriteUINT(hFile, 3);

		// Icon Position
		WriteINT(hFile, 10);
		WriteINT(hFile, 10);

		// Program Information
		WriteString(hFile, "i:\\bc45\\programs\\kittycom");
		WriteString(hFile, "kittycom.exe");
		WriteString(hFile, "");

  // Program Item Data
  WriteUINT(hFile, ITEM);

	 // Item Name
	 WriteString(hFile, "Paintbrush");

	 // Icon and Index
	 WriteString(hFile, "c:\\windows\\pbrush.exe");
	 WriteUINT(hFile, 0);

	 // Icon Position
	 WriteINT(hFile, 50);
	 WriteINT(hFile, 50);

	 // Program Information
	 WriteString(hFile, "c:\\windows");
	 WriteString(hFile, "pbrush.exe");
	 WriteString(hFile, "");

  // Close File
  _lclose(hFile);

  // Inform User on Completion
  MessageBox(HWND_DESKTOP, "Done", "CreateDesk", MB_OK | MB_ICONASTERISK);

  // Exit
  PostQuitMessage(0);
  return 0;
}

UINT WriteFile(HFILE hFile, LPCSTR lpszString)
{
  return _lwrite(hFile, lpszString, lstrlen(lpszString));
}

UINT WriteUINT(HFILE hFile, unsigned int Uint)
{
  return _lwrite(hFile, &Uint, sizeof(Uint));
}

UINT WriteULINT(HFILE hFile, unsigned long int Uint)
{
  return _lwrite(hFile, &Uint, sizeof(Uint));
}

UINT WriteINT(HFILE hFile, int Uint)
{
  return _lwrite(hFile, &Uint, sizeof(Uint));
}

UINT WriteString(HFILE hFile, LPCSTR lpszString)
{
  WriteUINT(hFile, lstrlen(lpszString));
  return WriteFile(hFile, lpszString);
}

