// KittyCat! Comm 1.0 for Windows 3.1
// by Steven Lawrance
// ---Dialing Directory File---

#include <windowsx.h>
#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include "Structs.h"
#include "Resource.h"
#include "Userintr.h"
#include "Distrbtr.h"

// Global Variables
DWORD HasChanged;
int AutoSave, gLineNumber;
HINSTANCE dllInstance;
HWND hMDIChild;
BBS bbs;
FILESTRUCT gfs;
INPUTDIALOGSTRUCT is;
int BBSOptionSelected;

/***********************************/

// DLL Routines
HINSTANCE FAR PASCAL _export Dialdir_GetDLLInstance(void);

// Dialing Directory Routines
void FAR PASCAL _export LoadBBSEntriesIntoMDI(FILESTRUCT fs);
void ComboBoxAdd(HWND hDlg, int ID, LPCSTR TextToAdd);
void DisplayLineInfo(HWND hDlg, int LineNumber, FILESTRUCT fs);
void DeleteNumber(UINT ReduceFlag, LPCSTR Entry, long LastEntry, LPCSTR Section);
void FAR PASCAL _export RenameEntry(HWND hWnd, FILESTRUCT fs);

// Dialing Directory Configuration
void FAR PASCAL _export DialDirConfig(HWND hWnd, FILESTRUCT fs);
BOOL CALLBACK _export DialDirConfigDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void WMDialDirConfigDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify);
void WMVScroll_Handler(HWND hWnd, HWND hwndCtl, UINT code, int pos);
void FAR PASCAL _export NewBBS(HWND hWnd, FILESTRUCT fs);
void FAR PASCAL _export DeleteBBS(HWND hWnd, FILESTRUCT fs);

// Input Dialog
INPUTDIALOGSTRUCT FAR PASCAL _export InputDialog(HWND hWnd, INPUTDIALOGSTRUCT Istr);
BOOL CALLBACK _export InputDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void WMInputDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify);

// BBS Options
void FAR PASCAL _export BBSOptions(HWND hWnd, FILESTRUCT fs);
BOOL CALLBACK _export BBSOptionsDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void WMBBSOptionsDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify);

/************************************/

// DLL Routines
#pragma argsused
int FAR PASCAL LibMain (HINSTANCE hInstance, WORD wDataSeg, WORD wHeapSize, LPSTR lpszCmdLine)
{
  if (wHeapSize > 0)
    UnlockData(0);
  dllInstance = hInstance;
  return 1;
}

HINSTANCE FAR PASCAL _export Dialdir_GetDLLInstance(void)
{
  return dllInstance;
}


// Dialing Directory Routines
void FAR PASCAL _export LoadBBSEntriesIntoMDI(FILESTRUCT fs)
{
  char Entry[11];
  char TmpStr[101];
  int NumEntries, i;
  memset(TmpStr, NULL, 101);
  GetPrivateProfileString("Directory", "NumberOfEntries", "1", TmpStr, 4, fs.FileName);
  NumEntries = atoi(TmpStr);
  for (i=1;i<=NumEntries;i++)
  {
    memset(Entry, NULL, 11);
    gcvt(i, 3, Entry);
    memset(TmpStr, NULL, 101);
    GetPrivateProfileString(Entry, "BBSName", "", TmpStr, 100, fs.FileName);
    if (strcmp(TmpStr, "") != 0)
      MakeNewChild(TmpStr);
  }
}

void ComboBoxAdd(HWND hDlg, int ID, LPCSTR TextToAdd)
{
  SendDlgItemMessage(hDlg, ID, CB_ADDSTRING, NULL, (LPARAM) TextToAdd);
}

void DisplayLineInfo(HWND hDlg, int LineNumber, FILESTRUCT fs)
{
  int NumEntries, i;
  char Entry[11];
  char TmpStr[50];
  char WorkStr[50];
  gLineNumber = LineNumber;
  memset(TmpStr, NULL, strlen(TmpStr));
  GetPrivateProfileString("Directory", "NumberOfEntries", "1", TmpStr, 4, fs.FileName);
  NumEntries = atol(TmpStr);
  for (i=1;i<=NumEntries;i++)
  {
    memset(Entry, NULL, strlen(Entry));
    gcvt(i, 3, Entry);
    memset(TmpStr, NULL, strlen(TmpStr));
    GetPrivateProfileString(Entry, "BBSName", "", TmpStr, 50, fs.FileName);
    if (strcmp(TmpStr, bbs.BBSName) == 0)
    {
      memset(WorkStr, NULL, strlen(WorkStr));
      strcpy(WorkStr, "Line ");
      memset(TmpStr, NULL, strlen(TmpStr));
      gcvt(LineNumber, 10, TmpStr);
      strcat(WorkStr, TmpStr);
      strcat(WorkStr, " of ");
      if (bbs.BBSLines == 0)
      {
	memset(TmpStr, NULL, strlen(TmpStr));
        GetPrivateProfileString(Entry, "AutoSave", "1", TmpStr, 4, fs.FileName);
	AutoSave = atol(TmpStr);
	SendDlgItemMessage(hDlg, 11, BM_SETCHECK, AutoSave, NULL);
	memset(TmpStr, NULL, strlen(TmpStr));
        GetPrivateProfileString(Entry, "NumberOfLines", "1", TmpStr, 4, fs.FileName);
	bbs.BBSLines = atol(TmpStr);
      }
      else
      {
	gcvt(bbs.BBSLines, 10, TmpStr);
      }
      strcat(WorkStr, TmpStr);
      SetDlgItemText(hDlg, 307, WorkStr);
      memset(TmpStr, NULL, strlen(TmpStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "Number");
      GetPrivateProfileString(Entry, TmpStr, "555-1212", bbs.BBSNumber, 50, fs.FileName);
      SetDlgItemText(hDlg, 308, bbs.BBSNumber);
      memset(TmpStr, NULL, strlen(TmpStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "Parity");
      GetPrivateProfileString(Entry, TmpStr, "Default", bbs.BBSParity, 10, fs.FileName);
      SendDlgItemMessage(hDlg, 300, CB_SELECTSTRING, -1, (LPARAM) (LPCSTR) bbs.BBSParity);
      memset(TmpStr, NULL, strlen(TmpStr));
      memset(WorkStr, NULL, strlen(WorkStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "BitsPerByte");
      GetPrivateProfileString(Entry, TmpStr, "0", WorkStr, 10, fs.FileName);
      bbs.BBSBitsPerByte = atol(WorkStr);
      if (bbs.BBSBitsPerByte == 0)
        strcpy(WorkStr, "Default");
      SendDlgItemMessage(hDlg, 301, CB_SELECTSTRING, -1, (LPARAM) (LPCSTR) WorkStr);
      memset(TmpStr, NULL, strlen(TmpStr));
      memset(WorkStr, NULL, strlen(WorkStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "StopBits");
      GetPrivateProfileString(Entry, TmpStr, "0", WorkStr, 10, fs.FileName);
      bbs.BBSStopBits = atol(WorkStr);
      if (bbs.BBSStopBits == 0)
        strcpy(WorkStr, "Default");
      SendDlgItemMessage(hDlg, 302, CB_SELECTSTRING, -1, (LPARAM) (LPCSTR) WorkStr);
      memset(TmpStr, NULL, strlen(TmpStr));
      memset(WorkStr, NULL, strlen(WorkStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "ModemErrorCorrection");
      GetPrivateProfileString(Entry, TmpStr, "2", WorkStr, 10, fs.FileName);
      bbs.EC = atol(WorkStr);
      SendDlgItemMessage(hDlg, 303, BM_SETCHECK, bbs.EC, NULL);
      memset(TmpStr, NULL, strlen(TmpStr));
      memset(WorkStr, NULL, strlen(WorkStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "Sound");
      GetPrivateProfileString(Entry, TmpStr, "2", WorkStr, 10, fs.FileName);
      bbs.Sound = atol(WorkStr);
      SendDlgItemMessage(hDlg, 304, BM_SETCHECK, bbs.Sound, NULL);
      memset(TmpStr, NULL, strlen(TmpStr));
      memset(WorkStr, NULL, strlen(WorkStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "CommPort");
      GetPrivateProfileString(Entry, TmpStr, "0", WorkStr, 10, fs.FileName);
      bbs.BBSCommPort = atol(WorkStr);
      if (bbs.BBSCommPort == 0)
        strcpy(WorkStr, "Default");
      SendDlgItemMessage(hDlg, 305, CB_SELECTSTRING, -1, (LPARAM) (LPCSTR) WorkStr);
    }
  }
}

void DeleteNumber(UINT ReduceFlag, LPCSTR Entry, long LastEntry, LPCSTR Section)
{
  char WorkStr[101];
  char TmpStr[101];
  memset(TmpStr, NULL, strlen(TmpStr));
  memset(WorkStr, NULL, strlen(WorkStr));
  gcvt(LastEntry, 4, TmpStr);
  strcat(TmpStr, Section);
  GetPrivateProfileString(Entry, TmpStr, "1", WorkStr, 100, gfs.FileName);
  WritePrivateProfileString(Entry, TmpStr, "", gfs.FileName);
  if (ReduceFlag == FALSE)
  {
    memset(TmpStr, NULL, strlen(TmpStr));
    gcvt(gLineNumber, 4, TmpStr);
    strcat(TmpStr, Section);
    WritePrivateProfileString(Entry, TmpStr, WorkStr, gfs.FileName);
  }
}

void FAR PASCAL _export RenameEntry(HWND hWnd, FILESTRUCT fs)
{
  INPUTDIALOGSTRUCT ids;
  char Entry[11];
  char TmpStr[110];
  int NumEntries, i;
  memset(&bbs, NULL, sizeof(&bbs));
  gfs = fs;
  memset(bbs.BBSName, NULL, strlen(bbs.BBSName));
  GetWindowText(hWnd, bbs.BBSName, 100);
  memset(TmpStr, NULL, strlen(TmpStr));
  GetPrivateProfileString("Directory", "NumberOfEntries", "1", TmpStr, 4, fs.FileName);
  NumEntries = atol(TmpStr);
  for (i=1;i<=NumEntries;i++)
  {
    memset(Entry, NULL, strlen(Entry));
    gcvt(i, 3, Entry);
    memset(TmpStr, NULL, strlen(TmpStr));
    GetPrivateProfileString(Entry, "BBSName", "", TmpStr, 100, fs.FileName);
    if (strcmp(TmpStr, bbs.BBSName) == 0)
    {
      memset(&ids, NULL, sizeof(&ids));
      strcpy(ids.WindowText, "Name for \"");
      strcat(ids.WindowText, bbs.BBSName);
      strcat(ids.WindowText, "\"");
      strcpy(ids.InstructionText, "Type in a new name or press [Cancel].");
      strcpy(ids.InitialAndReturnString, bbs.BBSName);
      strcpy(ids.CancelString, bbs.BBSName);
      ids = InputDialog(hWnd, ids);
      if (strcmp(ids.InitialAndReturnString, "") == 0)
      {
	Sound(MB_ICONEXCLAMATION);
	MessageBox(hWnd, "You Must Give Your BBS A Name!", "Rename Error", MB_OK | MB_ICONEXCLAMATION);
      }
      else
      {
        WritePrivateProfileString(Entry, "BBSName", ids.InitialAndReturnString, fs.FileName);
        SetWindowText(hWnd, ids.InitialAndReturnString);
        memset(bbs.BBSName, NULL, strlen(bbs.BBSName));
	strcpy(bbs.BBSName, ids.InitialAndReturnString);
      }
      goto End;
    }
  } 
  End:
}

void FAR PASCAL _export NewBBS(HWND hWnd, FILESTRUCT fs)
{
  char Entry[11];
  char TmpStr[101];
  int NumEntries, i;
  DWORD AddedYN = FALSE;
  memset(TmpStr, NULL, strlen(TmpStr));
  GetPrivateProfileString("Directory", "NumberOfEntries", "1", TmpStr, 4, fs.FileName);
  NumEntries = atol(TmpStr);
  for (i=1;i<=NumEntries;i++)
  {
    memset(Entry, NULL, strlen(Entry));
    gcvt(i, 3, Entry);
    memset(TmpStr, NULL, strlen(TmpStr));
    GetPrivateProfileString(Entry, "BBSName", "", TmpStr, 100, fs.FileName);
    if (strcmp(TmpStr, "") == 0)
    {
      AddedYN = TRUE;
      WritePrivateProfileString(Entry, "BBSName", "Recycled BBS", fs.FileName);
      hWnd = MakeNewChild("Recycled BBS");
      RenameEntry(hWnd, fs);
      DialDirConfig(hWnd, fs);
      goto End;
    }
  }
  if (AddedYN == FALSE)
  {
    memset(Entry, NULL, strlen(Entry));
    gcvt((NumEntries + 1), 3, Entry);
    WritePrivateProfileString("Directory", "NumberOfEntries", Entry, fs.FileName);
    WritePrivateProfileString(Entry, "BBSName", "New BBS", fs.FileName);
    WritePrivateProfileString(Entry, "NumberOfLines", "1", fs.FileName);
    hWnd = MakeNewChild("New BBS");
    RenameEntry(hWnd, fs);
    DialDirConfig(hWnd, fs);
  }
  End:
}

void FAR PASCAL _export DeleteBBS(HWND hWnd, FILESTRUCT fs)
{
  char Entry[11];
  char TmpStr[101];
  int NumEntries, i;
  memset(&bbs, NULL, sizeof(&bbs));
  GetWindowText(hWnd, bbs.BBSName, 100);
  memset(TmpStr, NULL, strlen(TmpStr));
  GetPrivateProfileString("Directory", "NumberOfEntries", "1", TmpStr, 4, fs.FileName);
  NumEntries = atol(TmpStr);
  for (i=1;i<=NumEntries;i++)
  {
    memset(Entry, NULL, strlen(Entry));
    gcvt(i, 3, Entry);
    memset(TmpStr, NULL, strlen(TmpStr));
    GetPrivateProfileString(Entry, "BBSName", "", TmpStr, 100, fs.FileName);
    if (strcmp(TmpStr, bbs.BBSName) == 0)
    {
      WritePrivateProfileString(Entry, "BBSName", "", fs.FileName);
    }
  }
}


// Dialing Directory Configuration
void FAR PASCAL _export DialDirConfig(HWND hWnd, FILESTRUCT fs)
{
  DLGPROC DlgProc;
  memset(&bbs, NULL, sizeof(&bbs));
  gfs = fs;
  GetWindowText(hWnd, bbs.BBSName, 100);
  DlgProc = (DLGPROC)MakeProcInstance((FARPROC)DialDirConfigDlgProc, dllInstance);
  DialogBox(Resource_GetDLLInstance(), "DIALDIRCFG", hWnd, DlgProc);
  FreeProcInstance((FARPROC)DlgProc);
}

#pragma argused
BOOL CALLBACK _export DialDirConfigDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch(message)
  {
    case WM_INITDIALOG :
    {
      char TmpStr[300];
      strcpy(TmpStr, "Config for \"");
      strcat(TmpStr, bbs.BBSName);
      strcat(TmpStr, "\"");
      SetWindowText(hDlg, TmpStr);
      ComboBoxAdd(hDlg, 300, "Default");
      ComboBoxAdd(hDlg, 300, "Even");
      ComboBoxAdd(hDlg, 300, "Mark");
      ComboBoxAdd(hDlg, 300, "None");
      ComboBoxAdd(hDlg, 300, "Odd");
      ComboBoxAdd(hDlg, 301, "Default");
      ComboBoxAdd(hDlg, 301, "4");
      ComboBoxAdd(hDlg, 301, "5");
      ComboBoxAdd(hDlg, 301, "6");
      ComboBoxAdd(hDlg, 301, "7");
      ComboBoxAdd(hDlg, 301, "8");
      ComboBoxAdd(hDlg, 302, "Default");
      ComboBoxAdd(hDlg, 302, "1");
      ComboBoxAdd(hDlg, 302, "1.5");
      ComboBoxAdd(hDlg, 302, "2");
      ComboBoxAdd(hDlg, 305, "Default");
      ComboBoxAdd(hDlg, 305, "1");
      ComboBoxAdd(hDlg, 305, "2");
      ComboBoxAdd(hDlg, 305, "3");
      ComboBoxAdd(hDlg, 305, "4");
      ComboBoxAdd(hDlg, 305, "5");
      ComboBoxAdd(hDlg, 305, "6");
      ComboBoxAdd(hDlg, 305, "7");
      ComboBoxAdd(hDlg, 305, "8");
      bbs.BBSLines = 0;
      DisplayLineInfo(hDlg, 1, gfs);
      SetScrollRange(GetDlgItem(hDlg, 311), SB_CTL, 1, bbs.BBSLines, TRUE);
      SetScrollPos(GetDlgItem(hDlg, 311), SB_CTL, gLineNumber, TRUE);
      HasChanged = FALSE;
      SendDlgItemMessage(hDlg, 308, EM_LIMITTEXT, 50, NULL);
      return TRUE;
    }
    case WM_MEASUREITEM :
    {
      LPMEASUREITEMSTRUCT lpmis1;
      LPMEASUREITEMSTRUCT lpmis2;
      LPMEASUREITEMSTRUCT lpmis3;
      lpmis1 = (MEASUREITEMSTRUCT FAR*) lParam;
      lpmis2 = (MEASUREITEMSTRUCT FAR*) lParam;
      lpmis3 = (MEASUREITEMSTRUCT FAR*) lParam;
      lpmis1 = InitButton(lpmis1, 306, 65, 41);
      lpmis2 = InitButton(lpmis2, 309, 65, 41);
      lpmis3 = InitButton(lpmis3, 310, 65, 41);
      return TRUE;
    }
    case WM_DRAWITEM :
    {
      LPDRAWITEMSTRUCT lpdis;
      char ButtonName[30];
      lpdis = (DRAWITEMSTRUCT FAR*) lParam;
      if (lpdis->CtlID == 306)
        strcpy(ButtonName, "CALL");
      if (lpdis->CtlID == 309)
        strcpy(ButtonName, "ADD");
      if (lpdis->CtlID == 310)
        strcpy(ButtonName, "DELETE");
      DrawButtonState(hDlg, lpdis, ButtonName);
      return TRUE;
    }
    case WM_COMMAND :
    {
      return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMDialDirConfigDlgCommand_Handler);
    }
    case WM_HSCROLL :
    {
      return HANDLE_WM_VSCROLL(hDlg, wParam, lParam, WMVScroll_Handler);
    }
  }
  return FALSE;
}

#pragma argsused
void WMDialDirConfigDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
  switch(id)
  {
    case 306 :
    {
      if (HasChanged == TRUE)
      {
	if (AutoSave == 1)
        {
	  SendMessage(hDlg, WM_COMMAND, 10, NULL);
	}
      }
      DialNumber(hDlg, gfs, bbs, gLineNumber);
      break;
    }
    case 309 :
    {
      if (codeNotify == BN_CLICKED)
      {
	if (bbs.BBSLines < 250)
        {
          bbs.BBSLines = bbs.BBSLines + 1;
          gLineNumber = bbs.BBSLines;
          SetScrollRange(GetDlgItem(hDlg, 311), SB_CTL, 1, bbs.BBSLines, TRUE);
	  SetScrollPos(GetDlgItem(hDlg, 311), SB_CTL, gLineNumber, TRUE);
	  DisplayLineInfo(hDlg, gLineNumber, gfs);
          HasChanged = FALSE;
	}
	else
	{
	  Sound(MB_ICONEXCLAMATION);
	  MessageBox(hDlg, "Don't you think you have enough lines?!", "Line Limit of 250", MB_OK | MB_ICONEXCLAMATION);
          break;
	}
      }
    }
    case 10 :
    {
      char Entry[11];
      char TmpStr[101];
      char WorkStr[101];
      int NumEntries, i, t;
      memset(TmpStr, NULL, strlen(TmpStr));
      GetPrivateProfileString("Directory", "NumberOfEntries", "1", TmpStr, 4, gfs.FileName);
      NumEntries = atol(TmpStr);
      for (i=1;i<=NumEntries;i++)
      {
        memset(Entry, NULL, strlen(Entry));
        gcvt(i, 3, Entry);
        memset(TmpStr, NULL, strlen(TmpStr));
	GetPrivateProfileString(Entry, "BBSName", "", TmpStr, 100, gfs.FileName);
        if (strcmp(TmpStr, bbs.BBSName) == 0)
        {
	  memset(TmpStr, NULL, strlen(TmpStr));
	  gcvt(bbs.BBSLines, 4, TmpStr);
	  WritePrivateProfileString(Entry, "NumberOfLines", TmpStr, gfs.FileName);
	  memset(TmpStr, NULL, strlen(TmpStr));
	  gcvt(AutoSave, 4, TmpStr);
	  WritePrivateProfileString(Entry, "AutoSave", TmpStr, gfs.FileName);
	  memset(WorkStr, NULL, strlen(WorkStr));
	  memset(TmpStr, NULL, strlen(TmpStr));
	  GetDlgItemText(hDlg, 308, WorkStr, 50);
          strcpy(bbs.BBSNumber, WorkStr);
	  gcvt(gLineNumber, 4, TmpStr);
	  strcat(TmpStr, "Number");
	  WritePrivateProfileString(Entry, TmpStr, WorkStr, gfs.FileName);
	  memset(WorkStr, NULL, strlen(WorkStr));
	  memset(TmpStr, NULL, strlen(TmpStr));
	  t = SendDlgItemMessage(hDlg, 300, CB_GETCURSEL, NULL, NULL);
	  SendDlgItemMessage(hDlg, 300, CB_GETLBTEXT, t, (LPARAM) (LPSTR) WorkStr);
          strcpy(bbs.BBSParity, WorkStr);
	  gcvt(gLineNumber, 4, TmpStr);
          strcat(TmpStr, "Parity");
	  WritePrivateProfileString(Entry, TmpStr, WorkStr, gfs.FileName);
	  memset(WorkStr, NULL, strlen(WorkStr));
	  memset(TmpStr, NULL, strlen(TmpStr));
	  t = SendDlgItemMessage(hDlg, 301, CB_GETCURSEL, NULL, NULL);
	  SendDlgItemMessage(hDlg, 301, CB_GETLBTEXT, t, (LPARAM) (LPSTR) WorkStr);
	  if (strcmp(WorkStr, "Default") == 0)
            strcpy(WorkStr, "0");
	  bbs.BBSBitsPerByte = atol(WorkStr);
	  gcvt(gLineNumber, 4, TmpStr);
          strcat(TmpStr, "BitsPerByte");
	  WritePrivateProfileString(Entry, TmpStr, WorkStr, gfs.FileName);
	  memset(WorkStr, NULL, strlen(WorkStr));
	  memset(TmpStr, NULL, strlen(TmpStr));
	  t = SendDlgItemMessage(hDlg, 302, CB_GETCURSEL, NULL, NULL);
	  SendDlgItemMessage(hDlg, 302, CB_GETLBTEXT, t, (LPARAM) (LPSTR) WorkStr);
	  if (strcmp(WorkStr, "Default") == 0)
            strcpy(WorkStr, "0");
	  bbs.BBSStopBits = atol(WorkStr);
	  gcvt(gLineNumber, 4, TmpStr);
          strcat(TmpStr, "StopBits");
	  WritePrivateProfileString(Entry, TmpStr, WorkStr, gfs.FileName);
	  memset(WorkStr, NULL, strlen(WorkStr));
	  memset(TmpStr, NULL, strlen(TmpStr));
	  t = SendDlgItemMessage(hDlg, 303, BM_GETCHECK, NULL, NULL);
	  bbs.EC = t;
	  gcvt(gLineNumber, 4, TmpStr);
          strcat(TmpStr, "ModemErrorCorrection");
          gcvt(t, 10, WorkStr);
	  WritePrivateProfileString(Entry, TmpStr, WorkStr, gfs.FileName);
	  memset(WorkStr, NULL, strlen(WorkStr));
	  memset(TmpStr, NULL, strlen(TmpStr));
	  t = SendDlgItemMessage(hDlg, 304, BM_GETCHECK, NULL, NULL);
	  bbs.Sound = t;
	  gcvt(gLineNumber, 4, TmpStr);
          strcat(TmpStr, "Sound");
          gcvt(t, 10, WorkStr);
	  WritePrivateProfileString(Entry, TmpStr, WorkStr, gfs.FileName);
	  memset(WorkStr, NULL, strlen(WorkStr));
	  memset(TmpStr, NULL, strlen(TmpStr));
	  t = SendDlgItemMessage(hDlg, 305, CB_GETCURSEL, NULL, NULL);
	  SendDlgItemMessage(hDlg, 305, CB_GETLBTEXT, t, (LPARAM) (LPSTR) WorkStr);
	  if (strcmp(WorkStr, "Default") == 0)
            strcpy(WorkStr, "0");
	  bbs.BBSCommPort = atol(WorkStr);
	  gcvt(gLineNumber, 4, TmpStr);
          strcat(TmpStr, "CommPort");
	  WritePrivateProfileString(Entry, TmpStr, WorkStr, gfs.FileName);
	}
      }
      HasChanged = FALSE;
      break;
    }
    case 2 :
    {
      if (HasChanged == TRUE)
      {
	Sound(MB_ICONQUESTION);
	if (MessageBox(hDlg, "Quit Without Saving?", "Cancel", MB_YESNO | MB_DEFBUTTON2 | MB_ICONQUESTION) == IDYES)
	  EndDialog(hDlg, 0);
      }
      else
      {
	EndDialog(hDlg, 0);
      }
      break;
    }
    case 310 :
    {
      if (codeNotify == BN_CLICKED)
      {
	if (bbs.BBSLines == 1)
	{
	  Sound(MB_ICONEXCLAMATION);
	  MessageBox(hDlg, "You Cannot Delete Your Only Number (Unless You Delete Your BBS Entry...)!", "Delete Number", MB_OK | MB_ICONEXCLAMATION);
	  goto End; 
        }
	Sound(MB_ICONQUESTION);
	if (MessageBox(hDlg, "Permanently Delete This Phone Number (You Can't Undelete It)?!", "Delete Number", MB_YESNO | MB_DEFBUTTON2 | MB_ICONQUESTION) == IDYES)
        {
	  char Entry[11];
	  char TmpStr[101];
	  int NumEntries, i, t;
          UINT ReduceFlag = FALSE;
	  memset(TmpStr, NULL, strlen(TmpStr));
          GetPrivateProfileString("Directory", "NumberOfEntries", "1", TmpStr, 4, gfs.FileName);
          NumEntries = atol(TmpStr);
          for (i=1;i<=NumEntries;i++)
          {
            memset(Entry, NULL, strlen(Entry));
	    gcvt(i, 3, Entry);
	    memset(TmpStr, NULL, strlen(TmpStr));
	    GetPrivateProfileString(Entry, "BBSName", "", TmpStr, 100, gfs.FileName);
            if (strcmp(TmpStr, bbs.BBSName) == 0)
            {
	      if ((bbs.BBSLines - 1) < gLineNumber)
              {
                gLineNumber = gLineNumber - 1;
		ReduceFlag = TRUE;
              }
	      DeleteNumber(ReduceFlag, Entry, bbs.BBSLines, "Parity");
	      DeleteNumber(ReduceFlag, Entry, bbs.BBSLines, "BitsPerByte");
	      DeleteNumber(ReduceFlag, Entry, bbs.BBSLines, "StopBits");
	      DeleteNumber(ReduceFlag, Entry, bbs.BBSLines, "ModemErrorCorrection");
	      DeleteNumber(ReduceFlag, Entry, bbs.BBSLines, "Number");
	      DeleteNumber(ReduceFlag, Entry, bbs.BBSLines, "Sound");
	      DeleteNumber(ReduceFlag, Entry, bbs.BBSLines, "CommPort");
	      bbs.BBSLines = bbs.BBSLines - 1;
	      SetScrollRange(GetDlgItem(hDlg, 311), SB_CTL, 1, bbs.BBSLines, TRUE);
	      memset(TmpStr, NULL, strlen(TmpStr));
              gcvt(bbs.BBSLines, 10, TmpStr);
	      WritePrivateProfileString(Entry, "NumberOfLines", TmpStr, gfs.FileName);
	      DisplayLineInfo(hDlg, gLineNumber, gfs);
	    }
	  }
	}
      }
      End:
      break;
    }
    case 500 :
    {
      SetScrollPos(GetDlgItem(hDlg, 311), SB_CTL, gLineNumber, TRUE);
      DisplayLineInfo(hDlg, gLineNumber, gfs);
      HasChanged = FALSE;
      break;
    }
  }
  if (codeNotify == EN_CHANGE)
  {
    HasChanged = TRUE;
  }
  if (codeNotify == CBN_SELCHANGE)
  {
    HasChanged = TRUE;
  }
  if (codeNotify == BN_CLICKED)
  {
    if (id == 303)
      HasChanged = TRUE;
    if (id == 304)
      HasChanged = TRUE;
    if (id == 11)
      AutoSave = SendDlgItemMessage(hDlg, 11, BM_GETCHECK, NULL, NULL);
  }
}

#pragma argsused
void WMVScroll_Handler(HWND hWnd, HWND hwndCtl, UINT code, int pos)
{
  switch (code)
  {
    case SB_PAGERIGHT :
    case SB_LINERIGHT :
    {
      if ((gLineNumber + 1) <= bbs.BBSLines)
      {
        if (HasChanged == TRUE)
        {
	  if (AutoSave == 1)
	  {
            SendMessage(hWnd, WM_COMMAND, 10, NULL);
	    gLineNumber = gLineNumber + 1;
	    SendMessage(hWnd, WM_COMMAND, 500, NULL);
	  }
	  else
          {
	    gLineNumber = gLineNumber + 1;
	    SendMessage(hWnd, WM_COMMAND, 500, NULL);
          }
	}
	else
	{
          gLineNumber = gLineNumber + 1;
	  SendMessage(hWnd, WM_COMMAND, 500, NULL);
	}
      }
      break;
    }
    case SB_PAGELEFT :
    case SB_LINELEFT :
    {
      if ((gLineNumber - 1) > 0)
      {
	if (HasChanged == TRUE)
        {
          if (AutoSave == 1)
	  {
            SendMessage(hWnd, WM_COMMAND, 10, NULL);
            gLineNumber = gLineNumber - 1;
	    SendMessage(hWnd, WM_COMMAND, 500, NULL);
	  }
  	  else
          {
	    gLineNumber = gLineNumber - 1;
	    SendMessage(hWnd, WM_COMMAND, 500, NULL);
          }
	}
	else
	{
	  gLineNumber = gLineNumber - 1;
	  SendMessage(hWnd, WM_COMMAND, 500, NULL);
	}
      }
      break;
    }
    case SB_THUMBTRACK :
    {
      if (HasChanged == TRUE)
      {
	if (AutoSave == 1)
	{
	  SendMessage(hWnd, WM_COMMAND, 10, NULL);
          gLineNumber = pos;
	  SendMessage(hWnd, WM_COMMAND, 500, NULL);
        }
        else
        {
	  gLineNumber = pos;
	  SendMessage(hWnd, WM_COMMAND, 500, NULL);
        }
      }
      else
      {
        gLineNumber = pos;
	SendMessage(hWnd, WM_COMMAND, 500, NULL);
      }
      break;
    }
  }
}


// Input Dialog
INPUTDIALOGSTRUCT FAR PASCAL _export InputDialog(HWND hWnd, INPUTDIALOGSTRUCT Istr)
{
  DLGPROC DlgProc;
  memset(&is, NULL, sizeof(&is));
  is = Istr;
  DlgProc = (DLGPROC)MakeProcInstance((FARPROC)InputDlgProc, dllInstance);
  DialogBox(Resource_GetDLLInstance(), "INPUTDIALOG", hWnd, DlgProc);
  FreeProcInstance((FARPROC)DlgProc);
  return is;
}

#pragma argused
BOOL CALLBACK _export InputDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch(message)
  {
    case WM_INITDIALOG :
    {
      SetWindowText(hDlg, is.WindowText);
      SetDlgItemText(hDlg, 300, is.InstructionText);
      SetDlgItemText(hDlg, 301, is.InitialAndReturnString);
      SendDlgItemMessage(hDlg, 301, EM_LIMITTEXT, 50, NULL); 
      return TRUE;
    }
    case WM_COMMAND :
    {
      return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMInputDlgCommand_Handler);
    }
  }
  return FALSE;
}

#pragma argsused
void WMInputDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
  switch(id)
  {
    case 1 :
    {
      GetDlgItemText(hDlg, 301, is.InitialAndReturnString, 50);
      EndDialog(hDlg, 0);
      break;
    }
    case 2 :
    {
      strcpy(is.InitialAndReturnString, is.CancelString);
      EndDialog(hDlg, 0);
      break;
    }
  }
}


// BBS Options
void FAR PASCAL _export BBSOptions(HWND hWnd, FILESTRUCT fs)
{
  DLGPROC DlgProc;
  BBSOptionSelected = 2;
  memset(&gfs, NULL, sizeof(&gfs));
  gfs = fs;
  hMDIChild = hWnd;
  DlgProc = (DLGPROC)MakeProcInstance((FARPROC)BBSOptionsDlgProc, dllInstance);
  DialogBoxParam(Resource_GetDLLInstance(), "DIALDIRCHOICE", hWnd, DlgProc, (LPARAM) hWnd);
  FreeProcInstance((FARPROC)DlgProc);
  switch (BBSOptionSelected)
  {
    case 300 :
    {
      // Dial Number
      gLineNumber = 1;
      GetWindowText(hMDIChild, bbs.BBSName, 50);
      DialNumber(hWnd, gfs, bbs, gLineNumber);
      break;
    }
    case 301 :
    {
      DialDirConfig(hWnd, gfs);
      break;
    }
    case 302 :
    {
      char TmpStr[100];
      RenameEntry(hWnd, gfs);
//      GetWindowText(hWnd, TmpStr, 100);
//      SetWindowText(hMDIChild, TmpStr);
      break;
    }
    case 303 :
    {
      char TmpStr[301];
      char TextStr[201];
      GetWindowText(hWnd, TextStr, 200);
      strcpy(TmpStr, "Are you sure you want to delete \"");
      strcat(TmpStr, TextStr);
      strcat(TmpStr, "\"?");
      Sound(MB_ICONEXCLAMATION);
      if (MessageBox(hWnd, TmpStr, "Delete BBS Entry", MB_YESNO | MB_DEFBUTTON2 | MB_ICONEXCLAMATION) == IDYES)
      {
	DeleteBBS(hMDIChild, gfs);
	DefMDIChildProc(hMDIChild, WM_CLOSE, NULL, NULL);
//	EndDialog(hDlg, 0);
      }
      break;
    }
  }
}

#pragma argused
BOOL CALLBACK _export BBSOptionsDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch(message)
  {
    case WM_INITDIALOG :
    {
      char TmpStr[100];
      GetWindowText((HWND) lParam, TmpStr, 100);
      SetWindowText(hDlg, TmpStr);
      return TRUE;
    }
    case WM_MEASUREITEM :
    {
      LPMEASUREITEMSTRUCT lpmis1;
      LPMEASUREITEMSTRUCT lpmis2;
      LPMEASUREITEMSTRUCT lpmis3;
      lpmis1 = (MEASUREITEMSTRUCT FAR*) lParam;
      lpmis2 = (MEASUREITEMSTRUCT FAR*) lParam;
      lpmis3 = (MEASUREITEMSTRUCT FAR*) lParam;
      lpmis1 = InitButton(lpmis1, 300, 65, 41);
      lpmis2 = InitButton(lpmis2, 301, 65, 41);
      lpmis3 = InitButton(lpmis3, 303, 65, 41);
      return TRUE;
    }
    case WM_DRAWITEM :
    {
      LPDRAWITEMSTRUCT lpdis;
      char ButtonName[30];
      lpdis = (DRAWITEMSTRUCT FAR*) lParam;
      if (lpdis->CtlID == 300)
        strcpy(ButtonName, "CALL");
      if (lpdis->CtlID == 301)
	strcpy(ButtonName, "CONFIG");
      if (lpdis->CtlID == 303)
	strcpy(ButtonName, "DELETE");
      DrawButtonState(hDlg, lpdis, ButtonName);
      return TRUE;
    }
    case WM_COMMAND :
    {
      return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMBBSOptionsDlgCommand_Handler);
    }
  }
  return FALSE;
}

#pragma argsused
void WMBBSOptionsDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
  switch(id)
  {
    case 300 :
    {
      // Dial Number
      BBSOptionSelected = 300;
      EndDialog(hDlg, 0);
      break;
    }
    case 301 :
    {
      BBSOptionSelected = 301;
//      DialDirConfig(hDlg, gfs);
      EndDialog(hDlg, 0);
      break;
    }
    case 302 :
    {
//      char TmpStr[100];
      BBSOptionSelected = 302;
/*      RenameEntry(hDlg, gfs);
      GetWindowText(hDlg, TmpStr, 100);
      SetWindowText(hMDIChild, TmpStr);*/
      EndDialog(hDlg, 0);
      break;
    }
    case 303 :
    {
//      char TmpStr[301];
//      char TextStr[201];
      BBSOptionSelected = 303;
/*      GetWindowText(hDlg, TextStr, 200);
      strcpy(TmpStr, "Are you sure you want to delete \"");
      strcat(TmpStr, TextStr);
      strcat(TmpStr, "\"?");
      Sound(MB_ICONEXCLAMATION);
      if (MessageBox(hDlg, TmpStr, "Delete BBS Entry", MB_YESNO | MB_DEFBUTTON2 | MB_ICONEXCLAMATION) == IDYES)
      {
	DeleteBBS(hMDIChild, gfs);
	DefMDIChildProc(hMDIChild, WM_CLOSE, NULL, NULL);
	EndDialog(hDlg, 0);
      }*/
      EndDialog(hDlg, 0);
      break;
    }
    case 2 :
    {
      BBSOptionSelected = 2;
      EndDialog(hDlg, 0);
      break;
    }
  }
}
