// KittyCat! Comm 1.0 for Windows 3.1
// by Steven Lawrance
// ---Communications Distribution File---

#include <windowsx.h>
#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <ddeml.h>
#include "Structs.h"
#include "Userintr.h"
#include "Resource.h"
#include "Catserve.h"

// Global Variables
HINSTANCE	 dllInstance;
BBS		 bbs;
FILESTRUCT	 gfs;
DWORD 		 CatCommOn, ConnectYN, PortOpened, result, Processed, Timer, ServerInitialized;
HDDEDATA	 hData;
HWND 		 ghWnd, ghDlg;
HCONV		 hConv;
FARPROC		 fnDdeCallBack;
HSZ		 hszService, hszTopic, hszItem;
DWORD		 idInst = 0L;
int		 hComm, gLineNumber, TimeLeft;

/***********************************/

// DLL Routines
HINSTANCE FAR PASCAL _export Distrbtr_GetDLLInstance(void);
void FAR PASCAL _export SetFileStruct(FILESTRUCT fs);

// Open Function
int FAR PASCAL _export OpenPort(BBS bbs, HWND hWnd);

// Data Convert And Send Functions
DWORD FAR PASCAL _export SendData(LPBYTE DataOut, long Bytes);
LPSTR FAR PASCAL _export ConvertDosControlsToWindows(char String[100]);

// Dialer
HDDEDATA FAR PASCAL _export DdeCallBackProc(UINT iType, UINT iFmt, HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD Data1, DWORD Data2);
void FAR PASCAL _export DialNumber(HWND hWnd, FILESTRUCT fs, BBS bbsx, int LineNumber);
BOOL CALLBACK _export DialingDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
void WMDialingDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify);
void WMDialingHScroll_Handler(HWND hWnd, HWND hwndCtl, UINT code, int pos);
void FAR PASCAL _export ClosePort(void);
BBS FAR PASCAL _export GetLineInfo(int LineNumber, FILESTRUCT fs, const char *BBSName);
DWORD CheckIncomingData(char DataPresent[2050]);

// Error Message Checks
int FAR PASCAL _export CheckErrorMessage(LPCSTR CheckString);
int FAR PASCAL _export CheckConnectMessage(LPCSTR CheckString);

/************************************/

// DLL Routines

#pragma argsused
int FAR PASCAL LibMain (HINSTANCE hInstance, WORD wDataSeg, WORD wHeapSize, LPSTR lpszCmdLine)
{
  if (wHeapSize > 0)
    UnlockData(0);
  dllInstance = hInstance;
  ServerInitialized = FALSE;
  PortOpened = FALSE;
  return 1;
}

HINSTANCE FAR PASCAL _export Distrbtr_GetDLLInstance(void)
{
  return dllInstance;
}


// Open Function
int FAR PASCAL _export OpenPort(BBS bbsx, HWND hWnd)
{
  DCB dcb;
  TIMERPROC QueryToReadData;
  char TmpStr[20];
  char WorkStr[50];
  if (bbsx.BBSStopBits == -2)
  {
    memset(bbs.BBSName, NULL, 50);
    strcpy(bbs.BBSName, bbsx.BBSName);
    GetLineInfo(bbsx.BBSBitsPerByte, gfs, bbsx.BBSName);
  }
  ghWnd = GetGlobalWindow();
  CatCommOn = FALSE;
  strcpy(WorkStr, "COM");
  gcvt(bbs.BBSCommPort, 20, TmpStr);
  strcat(WorkStr, TmpStr);
  hComm = OpenComm(WorkStr, 4096, 4096);
  if (hComm < 0)
  {
    Sound(MB_ICONSTOP);
    MessageBox(hWnd, "Trouble Opening Port!", WorkStr, MB_OK | MB_ICONSTOP);
    hComm = -1;
    goto End;
  }
  strcat(WorkStr, ":9600,");
  strcat(WorkStr, bbs.BBSParity);
  strcat(WorkStr, ",");
  memset(TmpStr, NULL, strlen(TmpStr));
  gcvt(bbs.BBSBitsPerByte, 20, TmpStr);
  strcat(WorkStr, TmpStr);
  strcat(WorkStr, ",");
  memset(TmpStr, NULL, strlen(TmpStr));
  gcvt(bbs.BBSStopBits, 20, TmpStr);
  strcat(WorkStr, TmpStr);
  if (BuildCommDCB(WorkStr, &dcb) == -1)
  {
    Sound(MB_ICONSTOP);
    MessageBox(hWnd, "Trouble Creating Data Control Blocks!", WorkStr, MB_OK | MB_ICONSTOP);
    dcb.fDtrDisable = TRUE;
    dcb.fRtsDisable = TRUE;
    SetCommState(&dcb);
    CloseComm(hComm);
    hComm = -1;
    goto End;
  }
  dcb.BaudRate = bbs.BBSLineSpeed;
  if (SetCommState(&dcb) < 0)
  {
    Sound(MB_ICONSTOP);
    MessageBox(hWnd, "Trouble Setting Communication State!", "Comm Error", MB_OK | MB_ICONSTOP);
    dcb.fDtrDisable = TRUE;
    dcb.fRtsDisable = TRUE;
    SetCommState(&dcb);
    CloseComm(hComm);
    hComm = -1;
    goto End;
  }
  End:
  if (hComm > 0)
    PortOpened = TRUE;
  return hComm;
}

LPSTR FAR PASCAL _export ConvertDosControlsToWindows(char String[100])
{
  char NewString[100];
  int i, t;
  t = 0;
  strupr(String);
  for (i=0;i<=strlen(String) - 1;i++)
  {
    if (String[i] == '^')
    {
      if (i == strlen(String) - 1)
      {
	goto WriteToIt;
      }
      if (String[i+1] == 'M')
      {
	NewString[t] = '\r';
	i = i + 1;
	t = t + 1;
        goto Next;
      }
      goto WriteToIt;
    }
    else
    {
      WriteToIt:
      NewString[t] = String[i];
      t = t + 1;
    }
    Next:
  }
  NewString[t] = '\0';
  return NewString;
}

#pragma argsused
DWORD FAR PASCAL _export SendData(LPBYTE DataOut, long Bytes)
{
  DWORD SuccessYN = TRUE;
  if (CatCommOn == TRUE)
  {
    // Write KittyCat Header and Calculate KittyCrc Values
  }
  if (CatCommOn == FALSE)
  {
    COMSTAT cs;
    GetCommError(hComm, &cs);
    if (4096 - cs.cbOutQue < Bytes)
    {
      SuccessYN = FALSE;
      goto End;
    }
    WriteComm(hComm, DataOut, Bytes);
  }
  End:
  return SuccessYN;
}


// Dialer
void FAR PASCAL _export DialNumber(HWND hWnd, FILESTRUCT fs, BBS bbsx, int LineNumber)
{
  DLGPROC DlgProc;
  int i;
  if (PortOpened == FALSE)
  {
    gfs = fs;
    bbs = bbsx;
    gLineNumber = LineNumber;
    GetLineInfo(gLineNumber, gfs, bbs.BBSName);
    OpenPort(bbs, hWnd);
    if (hComm < 0)
    {
      Sound(MB_ICONSTOP);
      MessageBox(hWnd, "Cannot open port!", "KittyCat! Comm Internal Error", MB_OK | MB_ICONSTOP);
      goto End;
    }
    PortOpened = TRUE;
  }
  else
  {
    char MessageString[130];
    memset(MessageString, NULL, 130);
    strcpy(MessageString, "Cannot call \"");
    strcat(MessageString, bbsx.BBSName);
    strcat(MessageString, "\" on account that \"");
    strcat(MessageString, bbs.BBSName);
    strcat(MessageString, "\" is currently in use!");
    Sound(MB_ICONEXCLAMATION);
    MessageBox(hWnd, MessageString, "Dialing Error", MB_OK | MB_ICONEXCLAMATION);
    goto End;
  }
  if (ServerInitialized == FALSE)
  {
    InitializeServer(hWnd, hComm);
    ServerInitialized = TRUE;
  }
  DlgProc = (DLGPROC)MakeProcInstance((FARPROC)DialingDlgProc, dllInstance);
  DialogBox(Resource_GetDLLInstance(), "DIALING", hWnd, DlgProc);
  FreeProcInstance((FARPROC)DlgProc);
  if (idInst != NULL)
  {
    FreeProcInstance((FARPROC)fnDdeCallBack);
    if (DdeDisconnect(hConv) == 0)
    {
      Sound(MB_ICONSTOP);
      MessageBox(ghWnd, "Cannot disconnect from server!  Exit KittyCat! Comm and run again.", "Fatal Error", MB_OK | MB_ICONSTOP);
    }
    if ((DdeFreeStringHandle(idInst, hszService) || DdeFreeStringHandle(idInst, hszTopic) || DdeFreeStringHandle(idInst, hszItem)) == 0)
    {
      Sound(MB_ICONSTOP);
      MessageBox(ghWnd, "Cannot free one or more of the DDE string handles!  Exit KittyCat! Comm and run again.", "Fatal Error", MB_OK | MB_ICONSTOP);
    }
    if (DdeUninitialize(idInst) == 0)
    {
      Sound(MB_ICONSTOP);
      MessageBox(ghWnd, "Cannot uninitialize DDE!  Exit KittyCat! Comm and run again.", "Fatal Error", MB_OK | MB_ICONSTOP);
    }
    idInst = 0L;
    FreeProcInstance(fnDdeCallBack);
    if (ConnectYN == 100)
    {
      char AnsiFile[300];
      memset(AnsiFile, NULL, 300);
      strcpy(AnsiFile, "ANSIRIPZ.EXE ");
      strcat(AnsiFile, bbs.BBSName);
      if (WinExec(AnsiFile, SW_SHOW) < 32)
      {
//	EndProgram();
	ClosePort();
        ServerInitialized = FALSE;
	Sound(MB_ICONSTOP);
	MessageBox(ghWnd, "The ANSI window file, \"ansiripz.exe\", could not load.  Make sure the file is in an accessable directory", "ANSI Window Error", MB_OK | MB_ICONSTOP);
      }
    }
    else
    {
//      EndProgram();
      ClosePort();
      ServerInitialized = FALSE;
    }
  }
  End:
}

#pragma argused
BOOL CALLBACK _export DialingDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch(message)
  {
    case WM_INITDIALOG :
    {
      char TmpStr[10];
      memset(TmpStr, NULL, 10);
      ghDlg = hDlg;
      SetWindowText(hDlg, bbs.BBSName);
      GetPrivateProfileString("Directory", "TimeLeft", "30", TmpStr, 3, gfs.FileName);
      TimeLeft = atol(TmpStr);
      SetScrollRange(GetDlgItem(hDlg, 302), SB_CTL, 1, 90, TRUE);
      SetScrollPos(GetDlgItem(hDlg, 302), SB_CTL, TimeLeft, TRUE);
      SetDlgItemInt(hDlg, 303, TimeLeft, FALSE);
      fnDdeCallBack = MakeProcInstance((FARPROC)DdeCallBackProc, dllInstance);
      idInst = 0;
      result = DdeInitialize(&idInst, (PFNCALLBACK)fnDdeCallBack, APPCMD_CLIENTONLY, 0L);
      if (result != DMLERR_NO_ERROR)
      {
        char ErrorText[100];
        memset(ErrorText, NULL, 100);
	Sound(MB_ICONSTOP);
        strcpy(ErrorText, "Cannot initialize DDE!");
	if (result == DMLERR_DLL_USAGE)
          strcat(ErrorText, "  DLL usage error.");
	if (result == DMLERR_INVALIDPARAMETER)
          strcat(ErrorText, "  Invalid parameter (internal error).");
	if (result == DMLERR_SYS_ERROR)
	  strcat(ErrorText, "  System error (internal error).");
	MessageBox(hDlg, ErrorText, "Fatal Dialing Error", MB_OK | MB_ICONSTOP);
	EndDialog(hDlg, 0);
	return FALSE;
      }
      hszService = DdeCreateStringHandle(idInst, "catcomm", CP_WINANSI);
      hszTopic = DdeCreateStringHandle(idInst, "comm", CP_WINANSI);
      hszItem = DdeCreateStringHandle(idInst, "comm", CP_WINANSI);
      if ((hszItem == NULL) || (hszTopic == NULL) || (hszService == NULL))
      {
	Sound(MB_ICONSTOP);
	MessageBox(hDlg, "Cannot create one or more of the DDE string handles!", "Fatal Error", MB_OK | MB_ICONSTOP);
	EndDialog(hDlg, 0);
	return FALSE;
      }
      hConv = DdeConnect(idInst, hszService, hszTopic, (PCONVCONTEXT) NULL);
      if (hConv == NULL)
      {
	Sound(MB_ICONSTOP);
	MessageBox(hDlg, "Cannot connect to server!", "Fatal Error", MB_OK | MB_ICONSTOP);
	EndDialog(hDlg, 0);
	return FALSE;
      }
      hData = DdeCreateDataHandle(idInst, "OLDANSI", sizeof("OLDANSI"), 0L, hszItem, CF_TEXT, NULL);
      if (hData == NULL)
      {
	Sound(MB_ICONSTOP);
	MessageBox(hDlg, "Cannot create data handle!", "Fatal Error", MB_OK | MB_ICONSTOP);
	EndDialog(hDlg, 0);
	return FALSE;
      }
      DdeClientTransaction((LPBYTE) hData, -1, hConv, hszItem, CF_TEXT, XTYP_POKE, 1000, &result);
      if (hData)
	DdeFreeDataHandle(hData);
      result = DdeGetLastError(idInst);
      if (result != DMLERR_NO_ERROR)
      {
	Sound(MB_ICONSTOP);
	MessageBox(hDlg, "Cannot send to server!", "Fatal Error", MB_OK | MB_ICONSTOP);
	EndDialog(hDlg, 0);
	return FALSE;
      }
      DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTART | XTYPF_ACKREQ, 1000, &result);
      result = DdeGetLastError(idInst);
      if (result != DMLERR_NO_ERROR)
      {
	Sound(MB_ICONSTOP);
	MessageBox(hDlg, "Cannot establish advise loop with server!", "Fatal Error", MB_OK | MB_ICONSTOP);
	EndDialog(hDlg, 0);
	return FALSE;
      }
      ConnectYN = 1;
      Timer = FALSE;
      Processed = FALSE;
      SetTimer(hDlg, 600, 1000, NULL);
      return TRUE;
    }
    case WM_TIMER :
    {
      char TmpStr[100];
      if ((Timer == TRUE) || (Timer == 10))
      {
        if (Timer == TRUE)
       	  TimeLeft = TimeLeft - 1;
        if (TimeLeft == 0)
        {
	  SetDlgItemText(hDlg, 301, "TimeOut");
	  ConnectYN = 12;
	}
        SetScrollPos(GetDlgItem(hDlg, 302), SB_CTL, TimeLeft, TRUE);
        SetDlgItemInt(hDlg, 303, TimeLeft, FALSE);
      }
      else
      {
	SetDlgItemText(hDlg, 303, "n/a");
      }
      if (Processed == FALSE)
      {
	Processed = TRUE;
        if (ConnectYN == 5)
        {
	  KillTimer(ghDlg, 600);
	  DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, 1000, &result);
	  EndDialog(hDlg, 0);
	}
        if (ConnectYN == 4)
        {
          DATASTRUCT ds;
	  SetDlgItemText(hDlg, 301, "Dialing Number");
	  ds = LoadDefaultStruct(ds);
	  memset(TmpStr, NULL, strlen(TmpStr));
	  strcpy(TmpStr, ds.DialPrefix);
          strcat(TmpStr, " ");
          strcat(TmpStr, bbs.BBSNumber);
	  strcat(TmpStr, ds.DialSuffix);
          strcpy(TmpStr, ConvertDosControlsToWindows(TmpStr));
	  if (SendData((LPBYTE) TmpStr, strlen(TmpStr)) == FALSE)
          {
	    Sound(MB_ICONSTOP);
            MessageBox(hDlg, "Error While Dialing Number!", "Comm Error", MB_OK | MB_ICONSTOP);
  	    KillTimer(ghDlg, 600);
	    DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, 1000, &result);
	    EndDialog(hDlg, 0);
            break;
	  }
	  TimeLeft = TimeLeft + 1;
	  Timer = TRUE;
	}
        if (ConnectYN == 3)
        {
	  DATASTRUCT ds;
          ds = LoadDefaultStruct(ds);
	  memset(TmpStr, NULL, strlen(TmpStr));
	  if (bbs.EC < 2)
          {
            SetDlgItemText(hDlg, 301, "Setting Error Correction");
	    if (bbs.EC == 1)
              strcpy(TmpStr, "AT&Q5^M");
	    if (bbs.EC == 0)
              strcpy(TmpStr, "AT&Q6^M");
   	    strcpy(TmpStr, ConvertDosControlsToWindows(TmpStr));
	    if (SendData((LPBYTE) TmpStr, strlen(TmpStr)) == FALSE)
            {
	      Sound(MB_ICONSTOP);
              MessageBox(hDlg, "Error While Setting Error Correction!", "Comm Error", MB_OK | MB_ICONSTOP);
	      KillTimer(ghDlg, 600);
	      DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, 1000, &result);
	      EndDialog(hDlg, 0);
              break;
	    }
	  }
	  else
          {
	    SetDlgItemText(hDlg, 301, "Skipping Error Correction");
	    ConnectYN = 4;
	    Processed = FALSE;
	  }
	}
        if (ConnectYN == 2)
        {
	  DATASTRUCT ds;
	  SetDlgItemText(hDlg, 301, "Setting Volume");
	  ds = LoadDefaultStruct(ds);
	  memset(TmpStr, NULL, strlen(TmpStr));
	  if (ds.Volume == -1)
            strcpy(TmpStr, "ATM0^M");
	  if (ds.Volume == 0)
            strcpy(TmpStr, "ATL0^M");
	  if (ds.Volume == 1)
            strcpy(TmpStr, "ATL1^M");
	  if (ds.Volume == 2)
            strcpy(TmpStr, "ATL2^M");
	  if (ds.Volume == 3)
	    strcpy(TmpStr, "ATL3^M");
	  strcpy(TmpStr, ConvertDosControlsToWindows(TmpStr));
	  if (SendData((LPBYTE) TmpStr, strlen(TmpStr)) == FALSE)
          {
	    Sound(MB_ICONSTOP);
	    MessageBox(hDlg, "Error While Setting Volume!", "Comm Error", MB_OK | MB_ICONSTOP);
 	    KillTimer(ghDlg, 600);
	    DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, 1000, &result);
	    EndDialog(hDlg, 0);
            break;
	  }
	}
        if (ConnectYN == 1)
        {
          DATASTRUCT ds;
          char TmpStr[100];
	  SetDlgItemText(hDlg, 301, "Initializing Modem");
	  ds = LoadDefaultStruct(ds);
          strcpy(ds.InitString, ConvertDosControlsToWindows(ds.InitString));
          if (SendData((LPBYTE) ds.InitString, strlen(ds.InitString)) == FALSE)
          {
	    Sound(MB_ICONSTOP);
            MessageBox(hDlg, "Error While Initializing!", "Comm Error", MB_OK | MB_ICONSTOP);
            KillTimer(hDlg, 600);
            DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, 1000, &result);
	    EndDialog(hDlg, 0);
            break;
          }
	  SetDlgItemText(hDlg, 300, bbs.BBSNumber);
        }
      }
      return 0;
    }
    case WM_COMMAND :
    {
      return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMDialingDlgCommand_Handler);
    }
    case WM_HSCROLL :
    {
      return HANDLE_WM_VSCROLL(hDlg, wParam, lParam, WMDialingHScroll_Handler);
    }
  }
  return FALSE;
}

#pragma argsused
void WMDialingDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
  switch(id)
  {
    case 304 :
    {
      char TmpStr[100];
      gcvt(TimeLeft, 100, TmpStr);
      WritePrivateProfileString("Directory", "TimeLeft", TmpStr, gfs.FileName);
      break;
    }
    case 2 :
    {
      KillTimer(hDlg, 600);
      DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, 1000, &result);
      EndDialog(hDlg, 0);
      break;
    }
  }
}

#pragma argsused
void WMDialingHScroll_Handler(HWND hWnd, HWND hwndCtl, UINT code, int pos)
{
  switch (code)
  {
    case SB_PAGERIGHT :
    {
      TimeLeft = TimeLeft + 10;
      if (TimeLeft > 90)
        TimeLeft = 90;
      break;
    }
    case SB_LINERIGHT :
    {
      TimeLeft = TimeLeft + 1;
      if (TimeLeft > 90)
        TimeLeft = 90;
      break;
    }
    case SB_PAGELEFT :
    {
      TimeLeft = TimeLeft - 10;
      if (TimeLeft < 1)
        TimeLeft = 1;
      break;
    }
    case SB_LINELEFT :
    {
      TimeLeft = TimeLeft - 1;
      if (TimeLeft < 1)
        TimeLeft = 1;
      break;
    }
    case SB_THUMBTRACK :
    {
      if (Timer == TRUE)
        Timer = 10;
      TimeLeft = pos;
      if (TimeLeft > 90)
        TimeLeft = 90;
      if (TimeLeft < 1)
        TimeLeft = 1;
      break;
    }
    case SB_THUMBPOSITION :
    {
      if (Timer == 10)
	Timer = TRUE;
      break;
    }
  }
  SetScrollPos(GetDlgItem(hWnd, 302), SB_CTL, TimeLeft, TRUE);
  SetDlgItemInt(hWnd, 303, TimeLeft, FALSE);
}

void FAR PASCAL _export ClosePort(void)
{
  if (PortOpened == TRUE)
  {
    DCB dcb;
    GetCommState(hComm, &dcb);
    dcb.fDtrDisable = TRUE;
    dcb.fRtsDisable = TRUE;
    SetCommState(&dcb);
    CloseComm(hComm);
    hComm = NULL;
    PortOpened = FALSE;
  }
}

BBS FAR PASCAL _export GetLineInfo(int LineNumber, FILESTRUCT fs, const char *BBSName)
{
  DATASTRUCT ds;
  char Entry[11];
  char TmpStr[50];
  char WorkStr[50];
  int NumEntries, i;
  ds = LoadDefaultStruct(ds);
  memset(TmpStr, NULL, strlen(TmpStr));
  strcpy(bbs.BBSName, BBSName);
  GetPrivateProfileString("Directory", "NumberOfEntries", "1", TmpStr, 4, fs.FileName);
  NumEntries = atol(TmpStr);
  for (i=1;i<=NumEntries;i++)
  {
    memset(Entry, NULL, strlen(Entry));
    gcvt(i, 3, Entry);
    memset(TmpStr, NULL, strlen(TmpStr));
    GetPrivateProfileString(Entry, "BBSName", "", TmpStr, 50, fs.FileName);
    if (strcmp(TmpStr, BBSName) == 0)
    {
      memset(TmpStr, NULL, strlen(TmpStr));
      GetPrivateProfileString(Entry, "NumberOfLines", "1", TmpStr, 4, fs.FileName);
      bbs.BBSLines = atol(TmpStr);
      memset(TmpStr, NULL, strlen(TmpStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "Number");
      GetPrivateProfileString(Entry, TmpStr, "555-1212", bbs.BBSNumber, 50, fs.FileName);
      memset(TmpStr, NULL, strlen(TmpStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "Parity");
      GetPrivateProfileString(Entry, TmpStr, "Default", bbs.BBSParity, 10, fs.FileName);
      if (strcmp(bbs.BBSParity, "Default") == 0)
      {
	strcpy(bbs.BBSParity, ds.CommParity);
      }
      else
      {
	memset(TmpStr, NULL, strlen(TmpStr));
	strncpy(TmpStr, bbs.BBSParity, 1);
	TmpStr[1] = '\0';
        strcpy(bbs.BBSParity, TmpStr);
      }
      memset(TmpStr, NULL, strlen(TmpStr));
      memset(WorkStr, NULL, strlen(WorkStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "BitsPerByte");
      GetPrivateProfileString(Entry, TmpStr, "0", WorkStr, 10, fs.FileName);
      bbs.BBSBitsPerByte = atol(WorkStr);
      if (bbs.BBSBitsPerByte == 0)
	bbs.BBSBitsPerByte = ds.CommByteSize;
      bbs.BBSLineSpeed = ds.CommSpeed;
      memset(TmpStr, NULL, strlen(TmpStr));
      memset(WorkStr, NULL, strlen(WorkStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "StopBits");
      GetPrivateProfileString(Entry, TmpStr, "0", WorkStr, 10, fs.FileName);
      bbs.BBSStopBits = atol(WorkStr);
      if (bbs.BBSStopBits == 0)
	bbs.BBSStopBits = ds.CommStopBits;
      memset(TmpStr, NULL, strlen(TmpStr));
      memset(WorkStr, NULL, strlen(WorkStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "ModemErrorCorrection");
      GetPrivateProfileString(Entry, TmpStr, "2", WorkStr, 10, fs.FileName);
      bbs.EC = atol(WorkStr);
      if (bbs.EC == 2)
	bbs.EC = ds.CommEC;
      memset(TmpStr, NULL, strlen(TmpStr));
      memset(WorkStr, NULL, strlen(WorkStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "Sound");
      GetPrivateProfileString(Entry, TmpStr, "2", WorkStr, 10, fs.FileName);
      bbs.Sound = atol(WorkStr);
      if (bbs.Sound == 0)
	bbs.Sound = GetSoundVariable();
      memset(TmpStr, NULL, strlen(TmpStr));
      memset(WorkStr, NULL, strlen(WorkStr));
      gcvt(LineNumber, 4, TmpStr);
      strcat(TmpStr, "CommPort");
      GetPrivateProfileString(Entry, TmpStr, "0", WorkStr, 10, fs.FileName);
      bbs.BBSCommPort = atol(WorkStr);
      if (bbs.BBSCommPort == 0)
      {
        strrev(ds.CommPort);
	bbs.BBSCommPort = atol(ds.CommPort);
	strrev(ds.CommPort);
      }
    }
  }
  return bbs;
}

int FAR PASCAL _export CheckErrorMessage(LPCSTR CheckString)
{
  int Returns = 0;
  RESULT result;
  result = LoadResultTable(result);
  if ((strcmp(result.NoConnect1, CheckString) == 0) && (strcmp(result.NoConnect1, "") != 0))
    Returns = 1;
  if ((strcmp(result.NoConnect2, CheckString) == 0) && (strcmp(result.NoConnect2, "") != 0))
    Returns = 2;
  if ((strcmp(result.NoConnect3, CheckString) == 0) && (strcmp(result.NoConnect3, "") != 0))
    Returns = 3;
  if ((strcmp(result.NoConnect4, CheckString) == 0) && (strcmp(result.NoConnect4, "") != 0))
    Returns = 4;
  if ((strcmp(result.NoConnect5, CheckString) == 0) && (strcmp(result.NoConnect5, "") != 0))
    Returns = 5;
  if ((strcmp(result.NoConnect6, CheckString) == 0) && (strcmp(result.NoConnect6, "") != 0))
    Returns = 6;
  return Returns;
}

int FAR PASCAL _export CheckConnectMessage(LPCSTR CheckString)
{
  int Returns = 0;
  RESULT result;
  result = LoadResultTable(result);
  if ((strcmp(result.Connect1200, CheckString) == 0) && (strcmp(result.Connect1200, "") != 0))
    Returns = 12;
  if ((strcmp(result.Connect2400, CheckString) == 0) && (strcmp(result.Connect2400, "") != 0))
    Returns = 24;
  if ((strcmp(result.Connect4800, CheckString) == 0) && (strcmp(result.Connect4800, "") != 0))
    Returns = 48;
  if ((strcmp(result.Connect9600, CheckString) == 0) && (strcmp(result.Connect9600, "") != 0))
    Returns = 96;
  if ((strcmp(result.Connect19200, CheckString) == 0) && (strcmp(result.Connect19200, "") != 0))
    Returns = 19;
  if ((strcmp(result.Connect38400, CheckString) == 0) && (strcmp(result.Connect38400, "") != 0))
    Returns = 38;
  if ((strcmp(result.Connect57600, CheckString) == 0) && (strcmp(result.Connect57600, "") != 0))
    Returns = 57;
  if ((strcmp(result.Connect115200, CheckString) == 0) && (strcmp(result.Connect115200, "") != 0))
    Returns = 115;
  if ((strcmp(result.Connect256000, CheckString) == 0) && (strcmp(result.Connect256000, "") != 0))
    Returns = 256;
  return Returns;
}

#pragma argsused
HDDEDATA FAR PASCAL _export DdeCallBackProc(UINT iType, UINT iFmt, HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD Data1, DWORD Data2)
{
  switch (iType)
  {
    case XTYP_ADVDATA :
    {
      char DataIn[2050];
      char DataPresent[100];
      memset(DataIn, NULL, 2050);
      DdeGetData(hData, DataIn, 2048, 0);
//      if (hData)
//        DdeFreeDataHandle(hData);
      result = DdeGetLastError(idInst);
      if (result != DMLERR_NO_ERROR)
      {
	Sound(MB_ICONSTOP);
	MessageBox(ghDlg, "Error with getting data!", "Fatal Error", MB_OK | MB_ICONSTOP);
	return ((HDDEDATA) NULL);
      }
      GetDlgItemText(ghDlg, 305, DataPresent, 98);
      if (DataPresent[strlen(DataPresent) - 1] == '\r')
	memset(DataPresent, NULL, 100);
      if ((strlen(DataPresent) + strlen(DataIn)) <= 98)
      {
	if (strlen(DataIn) > 1)
	{
	  int t, i;
	  if (DataPresent[strlen(DataPresent) - 1] == '\r')
          {
	    SetDlgItemText(ghDlg, 305, "");
	    strcpy(DataPresent, DataIn);
	  }
	  strcat(DataPresent, DataIn);
	  memset(DataIn, NULL, 2050);
          t = 0;
	  for (i=0;i<=strlen(DataPresent) - 1;i++)
	  {
	    if (DataPresent[i] == '\n')
            {
	      t = 0;
	    }
	    if (DataPresent[i] != '\n')
	    {
	      if (DataPresent[i] != '\r')
	      {
	        DataIn[t] = DataPresent[i];
                t = t + 1;
	      }
	      if (DataPresent[i] == '\r')
	      {
		DataIn[t] = '\0';
		SetDlgItemText(ghDlg, 305, DataIn);
		CheckIncomingData(DataIn);
		t = 0;
	      }
            }
          }
	  DataIn[t] = '\0';
	  if ((strlen(DataIn) > 0) && (DataIn[strlen(DataIn) - 1] != '\r'))
	    SetDlgItemText(ghDlg, 305, DataIn);
	}
	else
        {
	  if (DataPresent[strlen(DataPresent) - 1] == '\r')
          {
	    SetDlgItemText(ghDlg, 305, DataIn);
	    strcpy(DataPresent, DataIn);
	  }
	  if (DataIn[strlen(DataIn) - 1] == '\r')
	    CheckIncomingData(DataPresent);
	  else
	  {
	    strcat(DataPresent, DataIn);
            SetDlgItemText(ghDlg, 305, DataPresent);
	  }
	}
      }
      else
      {
        SetDlgItemText(ghDlg, 305, "");
      }
      return ((HDDEDATA) NULL);
    }
  }
  return ((HDDEDATA) NULL);
}

DWORD CheckIncomingData(char DataPresent[2050])
{
  if (strcmp("OK", DataPresent) == 0)
  {
    ConnectYN = ConnectYN + 1;
    Processed = FALSE;
    SetDlgItemText(ghDlg, 305, "OK\r");
    return TRUE;
  }
  if (strcmp("BUSY", DataPresent) == 0)
  {
    char TmpStr[10];
    SetDlgItemText(ghDlg, 301, "System Busy");
    gLineNumber = gLineNumber + 1;
    if (bbs.BBSLines < gLineNumber)
      gLineNumber = 1;
    GetLineInfo(gLineNumber, gfs, bbs.BBSName);
    SetDlgItemText(ghDlg, 305, "BUSY\r");
    Timer = FALSE;
    memset(TmpStr, NULL, 10);
    GetPrivateProfileString("Directory", "TimeLeft", "30", TmpStr, 3, gfs.FileName);
    TimeLeft = atol(TmpStr);
    SetScrollPos(GetDlgItem(ghDlg, 302), SB_CTL, TimeLeft, TRUE);
    ConnectYN = 1;
    Processed = FALSE;
    return TRUE;
  }
  if (CheckErrorMessage(DataPresent) != 0)
  {
    SetDlgItemText(ghDlg, 301, "Press [Cancel] and try again later.");
    Timer = FALSE;
    Sound(MB_ICONSTOP);
    return TRUE;
  }
  if (CheckConnectMessage(DataPresent) != 0)
  {
    SetDlgItemText(ghDlg, 301, "Connected to remote!");
    Sound(MB_ICONEXCLAMATION);
    ConnectYN = 100;
    KillTimer(ghDlg, 600);
    DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, 1000, &result);
    EndDialog(ghDlg, 0);
    return TRUE;
  }
  return FALSE;
}

void FAR PASCAL _export SetFileStruct(FILESTRUCT fs)
{
  memset(gfs.FileName, NULL, 144);
  strcpy(gfs.FileName, fs.FileName);
}

