
// remember to put in password support!!


// KittyCat! Desk 1.1 for Win16
// By Steven Lawrance
// ---Folder and Item File---

#include <windows.h>
#include <string.h>
#include <shellapi.h>
#include "ktydesk.h"

LRESULT CALLBACK _export FolderWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

BOOL ReadFolder(HFILE hFile, HWND hWnd)
{
  HWND hIconWnd, hFolderWnd;
  HBITMAP hBitmap;
  POINT pt;
  UINT fType;
  HICON hIcon;
  WINDOWPLACEMENT wp;
  unsigned int iLength;
  unsigned long int i;
  unsigned long int nItems;
  char Header[288];

  // Read Window State
  if (_lread(hFile, &fType, sizeof(fType)) == HFILE_ERROR) return FALSE;

  // Read Window Name
  memset(Header, NULL, 288);
  if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &Header, iLength) == HFILE_ERROR) return FALSE;
  hFolderWnd = CreateWindow("KittyCat! Desk 1.1 Folder", Header, WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX, CW_USEDEFAULT, CW_USEDEFAULT, 322, 240, hWnd, NULL, ghInstance, NULL);
  hIconWnd = CreateWindow("KittyCat! Desk 1.1 Item", Header, WS_MINIMIZE | WS_CHILD, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hWnd, NULL, ghInstance, NULL);
  SetWindowWord(hIconWnd, WW_FOLDERWND, hFolderWnd);
  if (fType) // Show Folder
	 ShowWindow(hFolderWnd, SW_SHOWNORMAL);
  else
	 ShowWindow(hFolderWnd, SW_HIDE);

  // Read Window Icon File Name
  memset(Header, NULL, 288);
  if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &Header, iLength) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
  hIcon = ExtractIcon(ghInstance, Header, iLength);
  SetWindowWord(hIconWnd, WW_HICON, hIcon);
  SetWindowWord(hFolderWnd, WW_HICON, hIcon);

  // Read Window Position for Folder and Set It
  if (_lread(hFile, &WindowRect.left, sizeof(WindowRect.left)) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &WindowRect.top, sizeof(WindowRect.top)) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &WindowRect.right, sizeof(WindowRect.right)) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &WindowRect.bottom, sizeof(WindowRect.bottom)) == HFILE_ERROR) return FALSE;
  SetWindowPos(hFolderWnd, NULL, WindowRect.left, WindowRect.top, WindowRect.right, WindowRect.bottom, SWP_NOZORDER);

  // Read Icon Position and Set It
  if (_lread(hFile, &pt.x, sizeof(pt.x)) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &pt.y, sizeof(pt.y)) == HFILE_ERROR) return FALSE;
  wp.length = sizeof(wp);
  wp.flags = WPF_SETMINPOSITION;
  wp.showCmd = SW_MINIMIZE;
  wp.ptMinPosition = pt;
  wp.ptMaxPosition = NULL;
  wp.rcNormalPosition = NULL;
  SetWindowPlacement(hIconWnd, &wp);

  // Read Background Picture File Name, Load It, and Display It
  memset(Header, NULL, 288);
  if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &Header, iLength) == HFILE_ERROR) return FALSE;
  hBitmap = OpenPicture(Header);
  if (hBitmap)
	 SetWindowWord(hFolderWnd, WW_HBITMAP, hBitmap);

  // Disregard Extension Information and Put hFile and Position in WinWords
  SetWindowWord(hFolderWnd, WW_HFILE, hFile);
  SetWindowWord(hFolderWnd, WW_EXTPOS, _llseek(hFile, 0, 1));
  SetWindowWord(hFolderWnd, WW_TYPE, FOLDER);
  if (_lread(hFile, &nItems, sizeof(nItems)) == HFILE_ERROR) return FALSE;
  for (i = 1; i <= nItems; i++)
  {
	 if (_lread(hFile, &fType, sizeof(fType)) == HFILE_ERROR) return FALSE;
	 if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
	 _llseek(hFile, iLength, 1);
  }

  // Read Number of Items in Folder and Process the Items
  if (_lread(hFile, &nItems, sizeof(nItems)) == HFILE_ERROR) return FALSE;
  for (i = 1; i <= nItems; i++)
  {
	 // Read Item Type
	 if (_lread(hFile, &fType, sizeof(fType)) == HFILE_ERROR) return FALSE;

	 // Send Types to Appropriate Areas
	 switch fType
	 {
		case FOLDER    : { ReadFolder(hFile, hWnd); break; }
		case ITEM      : { ReadItem(hFile, hWnd); break; }
		case EXTENSION : { ReadExtension(hFile, hWnd); break; }
		case LINK      : { ReadLink(hFile, hWnd); break }
	 }
  }
  return TRUE;
}

BOOL ReadItem(HFILE hFile, HWND hWnd)
{
  HWND hIconWnd;
  POINT pt;
  HICON hIcon;
  WINDOWPLACEMENT wp;
  unsigned int iLength;
  int i;
  char Header[288];

  // Read Window Name
  memset(Header, NULL, 288);
  if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &Header, iLength) == HFILE_ERROR) return FALSE;
  hIconWnd = CreateWindow("KittyCat! Desk 1.1 Item", Header, WS_MINIMIZE | WS_CHILD, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hWnd, NULL, hInstance, NULL);

  // Read Window Icon File Name
  memset(Header, NULL, 288);
  if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &Header, iLength) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
  hIcon = ExtractIcon(ghInstance, Header, iLength);
  SetWindowWord(hIconWnd, WW_HICON, hIcon);

  // Read Icon Position and Set It
  if (_lread(hFile, &pt.x, sizeof(pt.x)) == HFILE_ERROR) return FALSE;
  if (_lread(hFile, &pt.y, sizeof(pt.y)) == HFILE_ERROR) return FALSE;
  wp.length = sizeof(wp);
  wp.flags = WPF_SETMINPOSITION;
  wp.showCmd = SW_MINIMIZE;
  wp.ptMinPosition = pt;
  wp.ptMaxPosition = NULL;
  wp.rcNormalPosition = NULL;
  SetWindowPlacement(hIconWnd, &wp);

  // Disregard Program Information and Put hFile and Position in WinWords
  SetWindowWord(hFolderWnd, WW_HFILE, hFile);
  SetWindowWord(hFolderWnd, WW_PROGPOS, _llseek(hFile, 0, 1));
  SetWindowWord(hFolderWnd, WW_TYPE, ITEM);
  for (i = 1; i <= 3; i++)
  {
	 if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
	 if (_lread(hFile, &Header, iLength) == HFILE_ERROR) return FALSE;
  }
  return TRUE;
}

#pragma argsused
LRESULT CALLBACK _export IconWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message)
  {
	 case WM_CREATE :
	 {
		return 0;
	 }
	 case WM_PAINT :
	 {
		HDC hDC = GetDC(hWnd);

		DefWindowProc(hWnd, WM_ICONERASEBKGND, WORD(hDC), 0L);
		DrawIcon(hDC, 0, 0, hIcon);
		ReleaseDC(hWnd, hDC);
		return 0;
	 }
	 case WM_QUERYDRAGICON :
	 {
		return DWORD((HICON) GetWindowWord(hWnd, 0));
	 }
	 case WM_QUERYOPEN :
	 {
		switch (GetWindowWord(hWnd, WW_TYPE))
		{
		  case FOLDER :
		  {
			 // Show Folder Window
			 ShowWindow(GetWindowWord(hWnd, WW_FOLDERWND), SW_SHOWNORMAL);
			 break;
		  }
		  case ITEM :
		  {
			 // Set File Position To Program Info Position
			 HFILE hFile = GetWindowWord(hWnd, WW_HFILE);
			 unsigned int iLength;
			 char Program[288];
			 char Param[288];
			 char Directory[288];
			 _llseek(hFile, GetWindowWord(hWnd, WW_PROGPOS), 0);

			 // Read Program File, Param, and Directory
			 memset(Directory, NULL, 288);
			 if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
			 if (_lread(hFile, &Program, iLength) == HFILE_ERROR) return FALSE;
			 memset(Program, NULL, 288);
			 if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
			 if (_lread(hFile, &Param, iLength) == HFILE_ERROR) return FALSE;
			 memset(Param, NULL, 288);
			 if (_lread(hFile, &iLength, sizeof(iLength)) == HFILE_ERROR) return FALSE;
			 if (_lread(hFile, &Directory, iLength) == HFILE_ERROR) return FALSE;

			 // Run Item
			 if (ShellExecute(hWnd, NULL, Program, Param, Directory, SW_SHOWNORMAL) <= 32)
			 {
				MessageBeep(MB_ICONEXCLAMATION);
				MessageBox(hWnd, "Cannot Run Attempted Program!", "Run Error", MB_OK | MB_ICONEXCLAMATION);
			 }
			 break;
		  }
		}
		return 0;
	 }
  }
  return DefWindowProc(hWnd, message, wParam, lParam);
}

#pragma argsused
LRESULT CALLBACK _export FolderWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message)
  {
	 case WM_CREATE :
	 {
		return 0;
	 }
  }
  return DefWindowProc(hWnd, message, wParam, lParam);
}

