// KittyCat! Comm 1.0 for Windows 3.1
// MeowModem File Exchange
// by Steven Lawrance

#define STRICT

#include <windowsx.h>
#include <ddeml.h>
#include <stdlib.h>
#include <string.h>
#include <commdlg.h>

#define UPLOAD 1
#define DOWNLOAD 2

HCONV		 hConv;
FARPROC		 fnDdeCallBack;
HSZ		 hszService, hszTopic, hszItem;
DWORD		 idInst = 0L, result;
HDDEDATA	 hData;
HINSTANCE        ghInstance;
HFILE		 hFile;
LPSTR		 FileName;
int 		 TransferType;

// Function Prototypes
HDDEDATA FAR PASCAL _export DdeCallBackProc(UINT iType, UINT iFmt, HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD Data1, DWORD Data2);
BOOL CALLBACK _export MeowModemDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

/*******************************************/
#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdParam, int nCmdShow)
{
  DLGPROC MeowModemDlgProcHandle;
  if (hPrevInstance)
    return 0;
  lstrcpy(FileName, lpCmdParam);
//  if (lstrcmp(FileName, "") == 0)
    TransferType = DOWNLOAD;
//  else
//    TransferType = UPLOAD;
  ghInstance = hInstance;
  MeowModemDlgProcHandle = (DLGPROC) MakeProcInstance((FARPROC) MeowModemDlgProc, hInstance);
  DialogBox(hInstance, "MEOWMODEM", HWND_DESKTOP, MeowModemDlgProcHandle);
  FreeProcInstance((FARPROC) MeowModemDlgProcHandle);
  PostQuitMessage(0);
  return 0;
}

/*******************************************/

#pragma argsused
BOOL CALLBACK _export MeowModemDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message)
  {
    case WM_INITDIALOG :
    {
      fnDdeCallBack = MakeProcInstance((FARPROC)DdeCallBackProc, ghInstance);
      idInst = 0;
      result = DdeInitialize(&idInst, (PFNCALLBACK)fnDdeCallBack, APPCMD_CLIENTONLY, 0L);
      if (result != DMLERR_NO_ERROR)
      {
        char ErrorText[100];
        memset(ErrorText, NULL, 100);
        MessageBeep(MB_ICONSTOP);
        strcpy(ErrorText, "Cannot initialize DDE!");
        if (result == DMLERR_DLL_USAGE)
          strcat(ErrorText, "  DLL usage error.");
        if (result == DMLERR_INVALIDPARAMETER)
          strcat(ErrorText, "  Invalid parameter (internal error).");
        if (result == DMLERR_SYS_ERROR)
          strcat(ErrorText, "  System error (internal error).");
	MessageBox(hDlg, ErrorText, "Fatal Error", MB_OK | MB_ICONSTOP);
	EndDialog(hDlg, 0);
	return FALSE;
      }
      hszService = DdeCreateStringHandle(idInst, "catcomm", CP_WINANSI);
      hszTopic = DdeCreateStringHandle(idInst, "comm", CP_WINANSI);
      hszItem = DdeCreateStringHandle(idInst, "comm", CP_WINANSI);
      if ((hszItem == NULL) || (hszTopic == NULL) || (hszService == NULL))
      {
        MessageBeep(MB_ICONSTOP);
	MessageBox(hDlg, "Cannot create one or more of the DDE string handles!", "Fatal Error", MB_OK | MB_ICONSTOP);
        DdeUninitialize(idInst);
        idInst = 0L;
	EndDialog(hDlg, 0);
	return FALSE;
      }
      hConv = DdeConnect(idInst, hszService, hszTopic, (PCONVCONTEXT) NULL);
      if (hConv == NULL)
      {
	MessageBeep(MB_ICONEXCLAMATION);
	MessageBox(hDlg, "To use this program, KittyCat! Comm 1.0 must be loaded and connected to another computer via modem.", "MeowModem 1.0 Error", MB_OK | MB_ICONEXCLAMATION);
	DdeFreeStringHandle(idInst, hszService);
        DdeFreeStringHandle(idInst, hszTopic);
        DdeFreeStringHandle(idInst, hszItem);
        DdeUninitialize(idInst);
        idInst = 0L;
        EndDialog(hDlg, 0);
	return 0;
      }
      hData = DdeCreateDataHandle(idInst, FileName, sizeof(FileName), 0L, hszItem, CF_TEXT, NULL);
      if (hData == NULL)
      {
        MessageBeep(MB_ICONSTOP);
	MessageBox(hDlg, "Cannot create data handle!", "Fatal Error", MB_OK | MB_ICONSTOP);
	DdeDisconnect(hConv);
        DdeFreeStringHandle(idInst, hszService);
        DdeFreeStringHandle(idInst, hszTopic);
        DdeFreeStringHandle(idInst, hszItem);
        DdeUninitialize(idInst);
        idInst = 0L;
	EndDialog(hDlg, 0);
	return FALSE;
      }  
      hData = DdeClientTransaction((LPBYTE) hData, -1, hConv, hszItem, CF_TEXT, XTYP_POKE, 1000, &result);
      result = DdeGetLastError(idInst);
      if (result != DMLERR_NO_ERROR)
      {
        MessageBeep(MB_ICONSTOP);
	MessageBox(hDlg, "Cannot send to server!", "Fatal Error", MB_OK | MB_ICONSTOP);
	DdeDisconnect(hConv);
        DdeFreeStringHandle(idInst, hszService);
        DdeFreeStringHandle(idInst, hszTopic);
        DdeFreeStringHandle(idInst, hszItem);
        DdeUninitialize(idInst);
        idInst = 0L;
	EndDialog(hDlg, 0);
	return FALSE;
      }
      DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTART | XTYPF_ACKREQ, 1000, &result);
      result = DdeGetLastError(idInst);
      if (result != DMLERR_NO_ERROR)
      {
        MessageBeep(MB_ICONSTOP);
	MessageBox(hDlg, "Cannot establish advise loop with server!", "Fatal Error", MB_OK | MB_ICONSTOP);
        DdeDisconnect(hConv);
        DdeFreeStringHandle(idInst, hszService);
        DdeFreeStringHandle(idInst, hszTopic);
        DdeFreeStringHandle(idInst, hszItem);
        DdeUninitialize(idInst);
        idInst = 0L;
	EndDialog(hDlg, 0);
	return FALSE;
      }
      return 0;
    }
    case WM_COMMAND :
    {
      switch (wParam)
      {
	case 2 :
	{
	  DdeClientTransaction((LPBYTE) NULL, -1, hConv, hszItem, CF_TEXT, XTYP_ADVSTOP, 1000, &result);
	  FreeProcInstance((FARPROC)fnDdeCallBack);
	  if (idInst != NULL)
  	  {
	    if (DdeDisconnect(hConv) == 0)
  	    {
  	      MessageBeep(MB_ICONSTOP);
	      MessageBox(hDlg, "Cannot disconnect from server!  Exit KittyCat! Comm and run again.", "Fatal Error", MB_OK | MB_ICONSTOP);
	    }
	    if ((DdeFreeStringHandle(idInst, hszService) || DdeFreeStringHandle(idInst, hszTopic) || DdeFreeStringHandle(idInst, hszItem)) == 0)
  	    {
  	      MessageBeep(MB_ICONSTOP);
	      MessageBox(hDlg, "Cannot free one or more of the DDE string handles!  Exit KittyCat! Comm and run again.", "Fatal Error", MB_OK | MB_ICONSTOP);
  	    }
  	    if (DdeUninitialize(idInst) == 0)
  	    {
              MessageBeep(MB_ICONSTOP);
  	      MessageBox(hDlg, "Cannot uninitialize DDE!  Exit KittyCat! Comm and run again.", "Fatal Error", MB_OK | MB_ICONSTOP);
	    }
          }
	  EndDialog(hDlg, 0);
	  return 0;
        }
      }
      return FALSE;
    }
  }
  return FALSE;
}

#pragma argsused
HDDEDATA FAR PASCAL _export DdeCallBackProc(UINT iType, UINT iFmt, HCONV hConv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD Data1, DWORD Data2)
{
  if (iType == XTYP_ADVDATA)
  {
    char DataIn[2050];
    char MeowModemHeader[5];
    memset(MeowModemHeader, NULL, 5);
    memset(DataIn, NULL, 2050);
    DdeGetData(hData, MeowModemHeader, 1, 0);
    DdeGetData(hData, DataIn, 2047, 1);
    if (TransferType == DOWNLOAD)
    {
      // Download
      if (MeowModemHeader[0] == '!')
      {
        // Control Message
	if (strcmp(DataIn, "stop") == 0)
	{
          // File Transfer Abnormally Stopped
	}
	if (strcmp(DataIn, "begin") == 0)
	{
          // Begin
	  char *AckStr = "!begin";
	  DdeClientTransaction(AckStr, strlen(AckStr), hConv, hszItem, CF_TEXT, XTYP_POKE, 5000, &result);
	}
      }
      if (MeowModemHeader[0] == 'f')
      {
	// File Name Change
        lstrcpy(FileName, DataIn);
      }
      if (MeowModemHeader[0] == 'd')
      {
        // Date and Time of File
      }
      if (MeowModemHeader[0] == '$')
      {
        // Data To Write
	_lwrite(hFile, DataIn, strlen(DataIn));
      }
    }
    if (TransferType == UPLOAD)
    {
      // Upload
      if (MeowModemHeader[0] == '!')
      {
	if (strcmp(DataIn, "begin") == 0)
	{
	  // Begin Sending Data
	}
	if (strcmp(DataIn, "stop") == 0)
	{
          // Stop Sending Data
        }
      }
    }
    return NULL;
  }
  return NULL;
}
