BOOL FAR PASCAL _export KittyDdeSendData(HDOOR hDoor, LPBYTE lpData, int nBytes);
{
  // Send bytes
  BOOL bSuccess = TRUE;
  COMSTAT cs;
  unsigned long Crc;
  int i;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < nBytes) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 LPBYTE lpResendBuffer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, nBytes);

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_DATA);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Calculate KittyCrc64 value
	 for (i = 0; i <= nBytes - 1; i++)
		Crc = Crc + lpData[i];
	 WriteComm(ghComm, Crc, 4);
	 WriteComm(ghComm, Crc, 4);

	 // Send data length
	 WriteComm(ghComm, nBytes, 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 WriteComm(ghComm, lpData, nBytes);
	 lpResendBuffer = lpData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_DATA;
  }
  return bSuccess;
}

BOOL FAR PASCAL _export KittyDdeSendText(HDOOR hDoor, LPCSTR lpszData);
{
  // Send text
  BOOL bSuccess = TRUE;
  COMSTAT cs;
  unsigned long Crc;
  int i;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < lstrlen(lpszData)) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 LPSTR lpResendBuffer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, lstrlen(lpszData));

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_TEXT);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Calculate KittyCrc64 value
	 for (i = 0; i <= lstrlen(lpszData) - 1; i++)
		Crc = Crc + lpszData[i];
	 WriteComm(ghComm, Crc, 4);
	 WriteComm(ghComm, Crc, 4);

	 // Send data length
	 WriteComm(ghComm, lstrlen(lpszData), 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 WriteComm(ghComm, lpszData, nBytes);
	 lpResendBuffer = lpszData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_TEXT;
  }
  return bSuccess;
}

BOOL FAR PASCAL _export KittyDdeSendChar(HDOOR hDoor, char cData);
{
  // Send character
  BOOL bSuccess = TRUE;
  COMSTAT cs;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < 1) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 char lpResendBuffer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, 1);

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_CHAR);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 TransmitCommChar(ghComm, cData);
	 lpResendBuffer = cData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_CHAR;
  }
  return bSuccess;
}

BOOL FAR PASCAL _export KittyDdeSendUnsignedChar(HDOOR hDoor, unsigned char cData);
{
  // Send unsigned character
  BOOL bSuccess = TRUE;
  COMSTAT cs;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < 1) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 unsigned char lpResendBuffer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, 1);

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_UCHAR);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 TransmitCommChar(ghComm, (char) cData);
	 lpResendBuffer = cData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_UCHAR;
  }
  return bSuccess;
}

BOOL FAR PASCAL _export KittyDdeSendLong(HDOOR hDoor, long nData);
{
  // Send long
  BOOL bSuccess = TRUE;
  COMSTAT cs;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < 1) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 long lpResendBuffer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, 4);

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_LONG);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 WriteComm(ghComm, nData, 4);
	 lpResendBuffer = nData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_LONG;
  }
  return bSuccess;
}

BOOL FAR PASCAL _export KittyDdeSendUnsignedLong(HDOOR hDoor, unsigned long nData);
{
  // Send unsigned long
  BOOL bSuccess = TRUE;
  COMSTAT cs;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < 1) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 unsigned long lpResendBuffer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, 4);

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_ULONG);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 WriteComm(ghComm, nData, 4);
	 lpResendBuffer = nData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_ULONG;
  }
  return bSuccess;
}

BOOL FAR PASCAL _export KittyDdeSendInteger(HDOOR hDoor, int nData);
{
  // Send integer
  BOOL bSuccess = TRUE;
  COMSTAT cs;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < 1) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 int lpResendBuffer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, 2);

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_INT);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 WriteComm(ghComm, nData, 2);
	 lpResendBuffer = nData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_INT;
  }
  return bSuccess;
}

BOOL FAR PASCAL _export KittyDdeSendUnsignedInteger(HDOOR hDoor, unsigned int nData);
{
  // Send unsigned integer
  BOOL bSuccess = TRUE;
  COMSTAT cs;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < 1) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 unsigned int lpResendBuffer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, 2);

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_UINT);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 WriteComm(ghComm, nData, 2);
	 lpResendBuffer = nData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_UINT;
  }
  return bSuccess;
}

BOOL FAR PASCAL _export KittyDdeSendFloat(HDOOR hDoor, float fData);
{
  // Send float
  BOOL bSuccess = TRUE;
  COMSTAT cs;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < 1) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 float lpResendBuffer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, 4);

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_FLOAT);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 WriteComm(ghComm, fData, 4);
	 lpResendBuffer = fData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_FLOAT;
  }
  return bSuccess;
}

BOOL FAR PASCAL _export KittyDdeSendDouble(HDOOR hDoor, double dData);
{
  // Send double
  BOOL bSuccess = TRUE;
  COMSTAT cs;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < 1) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 double lpResendTransfer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, 8);

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_DOUBLE);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 WriteComm(ghComm, dData, 8);
	 lpResendBuffer = dData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_DOUBLE;
  }
  return bSuccess;
}

BOOL FAR PASCAL _export KittyDdeSendLongDouble(HDOOR hDoor, long double hData);
{
  // Send long double
  BOOL bSuccess = TRUE;
  COMSTAT cs;

  GetCommError(ghComm, &cs);
  if ((4096 - cs.cbOutQue < 1) || (bLastTransfer))
	 bSuccess = KITTYDDE_BUSY;
  else
  {
	 // Store info in resend buffer
	 long double lpResendTransfer;
	 lpLastTransfer = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, 10);

	 // Tell other computer to prepare to receive data
	 TransmitCommChar(ghComm, (char) KITTYDDE_LONGDOUBLE);

	 // Send remote handle
	 WriteComm(ghComm, Door[hDoor].hRemoteDoor, 2);

	 // Send data
	 lpResendBuffer = GlobalLock(lpLastTransfer);
	 WriteComm(ghComm, dData, 10);
	 lpResendBuffer = dData;
	 GlobalUnlock(lpLastTransfer);

	 // Tell other computer that transmittion is done
	 TransmitCommChar(ghComm, (char) KITTYDDE_DONE);

	 // Set transmittion variables
	 bLastTransfer = TRUE;
	 hLastTransferDoor = hDoor;
	 fLastTransferType = KITTYDDE_LONGDOUBLE;
  }
  return bSuccess;
}



HCOMPUTER FAR PASCAL _export InternalGetHComputer(HMODEM hModem)
{
  // Get computer handle from modem handle
  HCOMPUTER hComputer = -1;
  int i;
  for (i = 0; (i <= MAXCOMPUTER - 1) && (hComputer == -1); i++)
	 if (Computer[i].hModem == hModem)
		hComputer = i;
  return hComputer;
}


