// KittyCat! Comm 1.1 for Windows 3.1
// by Steven Lawrance
// ---Declarations---

typedef struct tagBBS {
  float CommStopBits;
  char CommPort[5];
  char CommParity;
  char InitString[100];
  char HangupString[50];
  char DialPrefix[50];
  char DialSuffix[50];
  long CommSpeed;
  int CommHandle;
  int ReadQueue;
  int SendQueue;
  int CommByteSize;
  int CommEC;
  int Volume;
} BBS;

typedef struct tagRESULT {
  char Connect1200[50];
  char Connect2400[50];
  char Connect4800[50];
  char Connect9600[50];
  char Connect14400[50];
  char Connect19200[50];
  char Connect38400[50];
  char Connect57600[50];
  char Connect115200[50];
  char Connect256000[50];
  char NoConnect1[50];
  char NoConnect2[50];
  char NoConnect3[50];
  char NoConnect4[50];
  char NoConnect5[50];
  char NoConnect6[50];
} RESULT;

typedef struct tagINPUTDIALOGSTRUCT {
  char WindowText[100];
  char InstructionText[100];
  char InitialAndReturnString[50];
  char CancelString[50];
} INPUTDIALOGSTRUCT;

typedef int HDIR;
typedef int HBBS;
typedef int HBBSNUMBER;
typedef int HDOOR;
typedef int HMODEM;
typedef int HCOMPUTER;

#define HTOKEN_INTERNAL         -4
#define HTOKEN_BADHCOMPUTER     -3
#define HTOKEN_FREE             -2
#define HTOKEN_ERROR            -1
#define HTOKEN_NA               0
#define HTOKEN_WAITING          1
#define HTOKEN_LOCKED           2
#define HTOKEN_UNLOCKED         3  // means it is used by resend buffer

#define DOOR_NORMAL             0
#define DOOR_NO_SOUND_NOTIFY    0x0001
#define DOOR_NO_RESUME_NOTIFY   0x0002
#define DOOR_NO_BUSY_NOTIFY     0x0004

#define HDOOR_NO_DOORS_LEFT      -1
#define HDOOR_NO_REMOTE_DOOR     -2
#define HDOOR_COMMBUSY           -3
#define HDOOR_BADHANDLE          -4
#define HDOOR_FLAGDISABLE        -5
#define HDOOR_BUSY_REGISTERING   -6

#define HMODEM_NO_MODEMS_LEFT    -1
#define HMODEM_COMMBUSY          -3
#define HMODEM_BADHANDLE         -4

#define KITTYDDE_DISCONNECTMSG   -7
#define KITTYDDE_RECONNECT       -6
#define KITTYDDE_DISCONNECT      -5
#define KITTYDDE_NO_TOKEN        -4
#define KITTYDDE_ALTERNATEDONE   -3
#define KITTYDDE_HCOMPUTERDONE   -2
#define KITTYDDE_HCOMPUTERSTRING -1
#define KITTYDDE_RESUME          0
#define KITTYDDE_WAIT            1
#define KITTYDDE_BUSY            2

#define KITTYDDE_RESEND          3
#define KITTYDDE_ERROR           4
#define KITTYDDE_OK              5
#define KITTYDDE_DONE            9

#define KITTYDDE_NEWSOUNDFLAG    10
#define KITTYDDE_NEWDOOR         15
#define KITTYDDE_NEWCOMPUTER     16
#define KITTYDDE_TERMINATEDOOR   19

#define KITTYDDE_DATA            20
#define KITTYDDE_TEXT            25
#define KITTYDDE_CHAR            26
#define KITTYDDE_UCHAR           27
#define KITTYDDE_INT             28
#define KITTYDDE_UINT            29
#define KITTYDDE_LONG            30
#define KITTYDDE_ULONG           31
#define KITTYDDE_FLOAT           32
#define KITTYDDE_DOUBLE          33
#define KITTYDDE_LONGDOUBLE      40

#ifdef STRICT
typedef BOOL (CALLBACK* KITTYDDEPROC)(HDOOR, char, HCOMPUTER, LPBYTE, WPARAM, LPARAM);
#else
typedef BOOL (CALLBACK* KITTYDDEPROC)(HDOOR, char, HCOMPUTER, LPBYTE, WPARAM, LPARAM);
#endif

